// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: google/api/auth.proto

package com.google.api;

/**
 * <pre>
 * `Authentication` defines the authentication configuration for an API.
 * Example for an API targeted for external use:
 *     name: calendar.googleapis.com
 *     authentication:
 *       providers:
 *       - id: google_calendar_auth
 *         jwks_uri: https://www.googleapis.com/oauth2/v1/certs
 *         issuer: https://securetoken.google.com
 *       rules:
 *       - selector: "*"
 *         requirements:
 *           provider_id: google_calendar_auth
 * </pre>
 *
 * Protobuf type {@code google.api.Authentication}
 */
public  final class Authentication extends
    com.google.protobuf.GeneratedMessageLite<
        Authentication, Authentication.Builder> implements
    // @@protoc_insertion_point(message_implements:google.api.Authentication)
    AuthenticationOrBuilder {
  private Authentication() {
    rules_ = emptyProtobufList();
    providers_ = emptyProtobufList();
  }
  public static final int RULES_FIELD_NUMBER = 3;
  private com.google.protobuf.Internal.ProtobufList<com.google.api.AuthenticationRule> rules_;
  /**
   * <pre>
   * A list of authentication rules that apply to individual API methods.
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
   */
  @java.lang.Override
  public java.util.List<com.google.api.AuthenticationRule> getRulesList() {
    return rules_;
  }
  /**
   * <pre>
   * A list of authentication rules that apply to individual API methods.
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
   */
  public java.util.List<? extends com.google.api.AuthenticationRuleOrBuilder> 
      getRulesOrBuilderList() {
    return rules_;
  }
  /**
   * <pre>
   * A list of authentication rules that apply to individual API methods.
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
   */
  @java.lang.Override
  public int getRulesCount() {
    return rules_.size();
  }
  /**
   * <pre>
   * A list of authentication rules that apply to individual API methods.
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
   */
  @java.lang.Override
  public com.google.api.AuthenticationRule getRules(int index) {
    return rules_.get(index);
  }
  /**
   * <pre>
   * A list of authentication rules that apply to individual API methods.
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
   */
  public com.google.api.AuthenticationRuleOrBuilder getRulesOrBuilder(
      int index) {
    return rules_.get(index);
  }
  private void ensureRulesIsMutable() {
    com.google.protobuf.Internal.ProtobufList<com.google.api.AuthenticationRule> tmp = rules_;
    if (!tmp.isModifiable()) {
      rules_ =
          com.google.protobuf.GeneratedMessageLite.mutableCopy(tmp);
     }
  }

  /**
   * <pre>
   * A list of authentication rules that apply to individual API methods.
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
   */
  private void setRules(
      int index, com.google.api.AuthenticationRule value) {
    value.getClass();
  ensureRulesIsMutable();
    rules_.set(index, value);
  }
  /**
   * <pre>
   * A list of authentication rules that apply to individual API methods.
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
   */
  private void addRules(com.google.api.AuthenticationRule value) {
    value.getClass();
  ensureRulesIsMutable();
    rules_.add(value);
  }
  /**
   * <pre>
   * A list of authentication rules that apply to individual API methods.
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
   */
  private void addRules(
      int index, com.google.api.AuthenticationRule value) {
    value.getClass();
  ensureRulesIsMutable();
    rules_.add(index, value);
  }
  /**
   * <pre>
   * A list of authentication rules that apply to individual API methods.
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
   */
  private void addAllRules(
      java.lang.Iterable<? extends com.google.api.AuthenticationRule> values) {
    ensureRulesIsMutable();
    com.google.protobuf.AbstractMessageLite.addAll(
        values, rules_);
  }
  /**
   * <pre>
   * A list of authentication rules that apply to individual API methods.
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
   */
  private void clearRules() {
    rules_ = emptyProtobufList();
  }
  /**
   * <pre>
   * A list of authentication rules that apply to individual API methods.
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
   */
  private void removeRules(int index) {
    ensureRulesIsMutable();
    rules_.remove(index);
  }

  public static final int PROVIDERS_FIELD_NUMBER = 4;
  private com.google.protobuf.Internal.ProtobufList<com.google.api.AuthProvider> providers_;
  /**
   * <pre>
   * Defines a set of authentication providers that a service supports.
   * </pre>
   *
   * <code>repeated .google.api.AuthProvider providers = 4;</code>
   */
  @java.lang.Override
  public java.util.List<com.google.api.AuthProvider> getProvidersList() {
    return providers_;
  }
  /**
   * <pre>
   * Defines a set of authentication providers that a service supports.
   * </pre>
   *
   * <code>repeated .google.api.AuthProvider providers = 4;</code>
   */
  public java.util.List<? extends com.google.api.AuthProviderOrBuilder> 
      getProvidersOrBuilderList() {
    return providers_;
  }
  /**
   * <pre>
   * Defines a set of authentication providers that a service supports.
   * </pre>
   *
   * <code>repeated .google.api.AuthProvider providers = 4;</code>
   */
  @java.lang.Override
  public int getProvidersCount() {
    return providers_.size();
  }
  /**
   * <pre>
   * Defines a set of authentication providers that a service supports.
   * </pre>
   *
   * <code>repeated .google.api.AuthProvider providers = 4;</code>
   */
  @java.lang.Override
  public com.google.api.AuthProvider getProviders(int index) {
    return providers_.get(index);
  }
  /**
   * <pre>
   * Defines a set of authentication providers that a service supports.
   * </pre>
   *
   * <code>repeated .google.api.AuthProvider providers = 4;</code>
   */
  public com.google.api.AuthProviderOrBuilder getProvidersOrBuilder(
      int index) {
    return providers_.get(index);
  }
  private void ensureProvidersIsMutable() {
    com.google.protobuf.Internal.ProtobufList<com.google.api.AuthProvider> tmp = providers_;
    if (!tmp.isModifiable()) {
      providers_ =
          com.google.protobuf.GeneratedMessageLite.mutableCopy(tmp);
     }
  }

  /**
   * <pre>
   * Defines a set of authentication providers that a service supports.
   * </pre>
   *
   * <code>repeated .google.api.AuthProvider providers = 4;</code>
   */
  private void setProviders(
      int index, com.google.api.AuthProvider value) {
    value.getClass();
  ensureProvidersIsMutable();
    providers_.set(index, value);
  }
  /**
   * <pre>
   * Defines a set of authentication providers that a service supports.
   * </pre>
   *
   * <code>repeated .google.api.AuthProvider providers = 4;</code>
   */
  private void addProviders(com.google.api.AuthProvider value) {
    value.getClass();
  ensureProvidersIsMutable();
    providers_.add(value);
  }
  /**
   * <pre>
   * Defines a set of authentication providers that a service supports.
   * </pre>
   *
   * <code>repeated .google.api.AuthProvider providers = 4;</code>
   */
  private void addProviders(
      int index, com.google.api.AuthProvider value) {
    value.getClass();
  ensureProvidersIsMutable();
    providers_.add(index, value);
  }
  /**
   * <pre>
   * Defines a set of authentication providers that a service supports.
   * </pre>
   *
   * <code>repeated .google.api.AuthProvider providers = 4;</code>
   */
  private void addAllProviders(
      java.lang.Iterable<? extends com.google.api.AuthProvider> values) {
    ensureProvidersIsMutable();
    com.google.protobuf.AbstractMessageLite.addAll(
        values, providers_);
  }
  /**
   * <pre>
   * Defines a set of authentication providers that a service supports.
   * </pre>
   *
   * <code>repeated .google.api.AuthProvider providers = 4;</code>
   */
  private void clearProviders() {
    providers_ = emptyProtobufList();
  }
  /**
   * <pre>
   * Defines a set of authentication providers that a service supports.
   * </pre>
   *
   * <code>repeated .google.api.AuthProvider providers = 4;</code>
   */
  private void removeProviders(int index) {
    ensureProvidersIsMutable();
    providers_.remove(index);
  }

  public static com.google.api.Authentication parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data);
  }
  public static com.google.api.Authentication parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data, extensionRegistry);
  }
  public static com.google.api.Authentication parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data);
  }
  public static com.google.api.Authentication parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data, extensionRegistry);
  }
  public static com.google.api.Authentication parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data);
  }
  public static com.google.api.Authentication parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data, extensionRegistry);
  }
  public static com.google.api.Authentication parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input);
  }
  public static com.google.api.Authentication parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input, extensionRegistry);
  }
  public static com.google.api.Authentication parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return parseDelimitedFrom(DEFAULT_INSTANCE, input);
  }
  public static com.google.api.Authentication parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return parseDelimitedFrom(DEFAULT_INSTANCE, input, extensionRegistry);
  }
  public static com.google.api.Authentication parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input);
  }
  public static com.google.api.Authentication parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input, extensionRegistry);
  }

  public static Builder newBuilder() {
    return (Builder) DEFAULT_INSTANCE.createBuilder();
  }
  public static Builder newBuilder(com.google.api.Authentication prototype) {
    return (Builder) DEFAULT_INSTANCE.createBuilder(prototype);
  }

  /**
   * <pre>
   * `Authentication` defines the authentication configuration for an API.
   * Example for an API targeted for external use:
   *     name: calendar.googleapis.com
   *     authentication:
   *       providers:
   *       - id: google_calendar_auth
   *         jwks_uri: https://www.googleapis.com/oauth2/v1/certs
   *         issuer: https://securetoken.google.com
   *       rules:
   *       - selector: "*"
   *         requirements:
   *           provider_id: google_calendar_auth
   * </pre>
   *
   * Protobuf type {@code google.api.Authentication}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageLite.Builder<
        com.google.api.Authentication, Builder> implements
      // @@protoc_insertion_point(builder_implements:google.api.Authentication)
      com.google.api.AuthenticationOrBuilder {
    // Construct using com.google.api.Authentication.newBuilder()
    private Builder() {
      super(DEFAULT_INSTANCE);
    }


    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    @java.lang.Override
    public java.util.List<com.google.api.AuthenticationRule> getRulesList() {
      return java.util.Collections.unmodifiableList(
          instance.getRulesList());
    }
    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    @java.lang.Override
    public int getRulesCount() {
      return instance.getRulesCount();
    }/**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    @java.lang.Override
    public com.google.api.AuthenticationRule getRules(int index) {
      return instance.getRules(index);
    }
    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public Builder setRules(
        int index, com.google.api.AuthenticationRule value) {
      copyOnWrite();
      instance.setRules(index, value);
      return this;
    }
    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public Builder setRules(
        int index, com.google.api.AuthenticationRule.Builder builderForValue) {
      copyOnWrite();
      instance.setRules(index,
          builderForValue.build());
      return this;
    }
    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public Builder addRules(com.google.api.AuthenticationRule value) {
      copyOnWrite();
      instance.addRules(value);
      return this;
    }
    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public Builder addRules(
        int index, com.google.api.AuthenticationRule value) {
      copyOnWrite();
      instance.addRules(index, value);
      return this;
    }
    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public Builder addRules(
        com.google.api.AuthenticationRule.Builder builderForValue) {
      copyOnWrite();
      instance.addRules(builderForValue.build());
      return this;
    }
    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public Builder addRules(
        int index, com.google.api.AuthenticationRule.Builder builderForValue) {
      copyOnWrite();
      instance.addRules(index,
          builderForValue.build());
      return this;
    }
    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public Builder addAllRules(
        java.lang.Iterable<? extends com.google.api.AuthenticationRule> values) {
      copyOnWrite();
      instance.addAllRules(values);
      return this;
    }
    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public Builder clearRules() {
      copyOnWrite();
      instance.clearRules();
      return this;
    }
    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public Builder removeRules(int index) {
      copyOnWrite();
      instance.removeRules(index);
      return this;
    }

    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    @java.lang.Override
    public java.util.List<com.google.api.AuthProvider> getProvidersList() {
      return java.util.Collections.unmodifiableList(
          instance.getProvidersList());
    }
    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    @java.lang.Override
    public int getProvidersCount() {
      return instance.getProvidersCount();
    }/**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    @java.lang.Override
    public com.google.api.AuthProvider getProviders(int index) {
      return instance.getProviders(index);
    }
    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public Builder setProviders(
        int index, com.google.api.AuthProvider value) {
      copyOnWrite();
      instance.setProviders(index, value);
      return this;
    }
    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public Builder setProviders(
        int index, com.google.api.AuthProvider.Builder builderForValue) {
      copyOnWrite();
      instance.setProviders(index,
          builderForValue.build());
      return this;
    }
    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public Builder addProviders(com.google.api.AuthProvider value) {
      copyOnWrite();
      instance.addProviders(value);
      return this;
    }
    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public Builder addProviders(
        int index, com.google.api.AuthProvider value) {
      copyOnWrite();
      instance.addProviders(index, value);
      return this;
    }
    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public Builder addProviders(
        com.google.api.AuthProvider.Builder builderForValue) {
      copyOnWrite();
      instance.addProviders(builderForValue.build());
      return this;
    }
    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public Builder addProviders(
        int index, com.google.api.AuthProvider.Builder builderForValue) {
      copyOnWrite();
      instance.addProviders(index,
          builderForValue.build());
      return this;
    }
    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public Builder addAllProviders(
        java.lang.Iterable<? extends com.google.api.AuthProvider> values) {
      copyOnWrite();
      instance.addAllProviders(values);
      return this;
    }
    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public Builder clearProviders() {
      copyOnWrite();
      instance.clearProviders();
      return this;
    }
    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public Builder removeProviders(int index) {
      copyOnWrite();
      instance.removeProviders(index);
      return this;
    }

    // @@protoc_insertion_point(builder_scope:google.api.Authentication)
  }
  @java.lang.Override
  @java.lang.SuppressWarnings({"unchecked", "fallthrough"})
  protected final java.lang.Object dynamicMethod(
      com.google.protobuf.GeneratedMessageLite.MethodToInvoke method,
      java.lang.Object arg0, java.lang.Object arg1) {
    switch (method) {
      case NEW_MUTABLE_INSTANCE: {
        return new com.google.api.Authentication();
      }
      case NEW_BUILDER: {
        return new Builder();
      }
      case BUILD_MESSAGE_INFO: {
          java.lang.Object[] objects = new java.lang.Object[] {
            "rules_",
            com.google.api.AuthenticationRule.class,
            "providers_",
            com.google.api.AuthProvider.class,
          };
          java.lang.String info =
              "\u0000\u0002\u0000\u0000\u0003\u0004\u0002\u0000\u0002\u0000\u0003\u001b\u0004\u001b" +
              "";
          return newMessageInfo(DEFAULT_INSTANCE, info, objects);
      }
      // fall through
      case GET_DEFAULT_INSTANCE: {
        return DEFAULT_INSTANCE;
      }
      case GET_PARSER: {
        com.google.protobuf.Parser<com.google.api.Authentication> parser = PARSER;
        if (parser == null) {
          synchronized (com.google.api.Authentication.class) {
            parser = PARSER;
            if (parser == null) {
              parser =
                  new DefaultInstanceBasedParser<com.google.api.Authentication>(
                      DEFAULT_INSTANCE);
              PARSER = parser;
            }
          }
        }
        return parser;
    }
    case GET_MEMOIZED_IS_INITIALIZED: {
      return (byte) 1;
    }
    case SET_MEMOIZED_IS_INITIALIZED: {
      return null;
    }
    }
    throw new UnsupportedOperationException();
  }


  // @@protoc_insertion_point(class_scope:google.api.Authentication)
  private static final com.google.api.Authentication DEFAULT_INSTANCE;
  static {
    Authentication defaultInstance = new Authentication();
    // New instances are implicitly immutable so no need to make
    // immutable.
    DEFAULT_INSTANCE = defaultInstance;
    com.google.protobuf.GeneratedMessageLite.registerDefaultInstance(
      Authentication.class, defaultInstance);
  }

  public static com.google.api.Authentication getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static volatile com.google.protobuf.Parser<Authentication> PARSER;

  public static com.google.protobuf.Parser<Authentication> parser() {
    return DEFAULT_INSTANCE.getParserForType();
  }
}

