// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: google/speech/v1/cloud_speech.proto

package com.google.cloud.speech.v1;

/**
 * <pre>
 * Description of audio data to be recognized.
 * </pre>
 *
 * Protobuf type {@code google.cloud.speech.v1.RecognitionMetadata}
 */
public  final class RecognitionMetadata extends
    com.google.protobuf.GeneratedMessageLite<
        RecognitionMetadata, RecognitionMetadata.Builder> implements
    // @@protoc_insertion_point(message_implements:google.cloud.speech.v1.RecognitionMetadata)
    RecognitionMetadataOrBuilder {
  private RecognitionMetadata() {
    recordingDeviceName_ = "";
    originalMimeType_ = "";
    audioTopic_ = "";
  }
  /**
   * <pre>
   * Use case categories that the audio recognition request can be described
   * by.
   * </pre>
   *
   * Protobuf enum {@code google.cloud.speech.v1.RecognitionMetadata.InteractionType}
   */
  public enum InteractionType
      implements com.google.protobuf.Internal.EnumLite {
    /**
     * <pre>
     * Use case is either unknown or is something other than one of the other
     * values below.
     * </pre>
     *
     * <code>INTERACTION_TYPE_UNSPECIFIED = 0;</code>
     */
    INTERACTION_TYPE_UNSPECIFIED(0),
    /**
     * <pre>
     * Multiple people in a conversation or discussion. For example in a
     * meeting with two or more people actively participating. Typically
     * all the primary people speaking would be in the same room (if not,
     * see PHONE_CALL)
     * </pre>
     *
     * <code>DISCUSSION = 1;</code>
     */
    DISCUSSION(1),
    /**
     * <pre>
     * One or more persons lecturing or presenting to others, mostly
     * uninterrupted.
     * </pre>
     *
     * <code>PRESENTATION = 2;</code>
     */
    PRESENTATION(2),
    /**
     * <pre>
     * A phone-call or video-conference in which two or more people, who are
     * not in the same room, are actively participating.
     * </pre>
     *
     * <code>PHONE_CALL = 3;</code>
     */
    PHONE_CALL(3),
    /**
     * <pre>
     * A recorded message intended for another person to listen to.
     * </pre>
     *
     * <code>VOICEMAIL = 4;</code>
     */
    VOICEMAIL(4),
    /**
     * <pre>
     * Professionally produced audio (eg. TV Show, Podcast).
     * </pre>
     *
     * <code>PROFESSIONALLY_PRODUCED = 5;</code>
     */
    PROFESSIONALLY_PRODUCED(5),
    /**
     * <pre>
     * Transcribe spoken questions and queries into text.
     * </pre>
     *
     * <code>VOICE_SEARCH = 6;</code>
     */
    VOICE_SEARCH(6),
    /**
     * <pre>
     * Transcribe voice commands, such as for controlling a device.
     * </pre>
     *
     * <code>VOICE_COMMAND = 7;</code>
     */
    VOICE_COMMAND(7),
    /**
     * <pre>
     * Transcribe speech to text to create a written document, such as a
     * text-message, email or report.
     * </pre>
     *
     * <code>DICTATION = 8;</code>
     */
    DICTATION(8),
    UNRECOGNIZED(-1),
    ;

    /**
     * <pre>
     * Use case is either unknown or is something other than one of the other
     * values below.
     * </pre>
     *
     * <code>INTERACTION_TYPE_UNSPECIFIED = 0;</code>
     */
    public static final int INTERACTION_TYPE_UNSPECIFIED_VALUE = 0;
    /**
     * <pre>
     * Multiple people in a conversation or discussion. For example in a
     * meeting with two or more people actively participating. Typically
     * all the primary people speaking would be in the same room (if not,
     * see PHONE_CALL)
     * </pre>
     *
     * <code>DISCUSSION = 1;</code>
     */
    public static final int DISCUSSION_VALUE = 1;
    /**
     * <pre>
     * One or more persons lecturing or presenting to others, mostly
     * uninterrupted.
     * </pre>
     *
     * <code>PRESENTATION = 2;</code>
     */
    public static final int PRESENTATION_VALUE = 2;
    /**
     * <pre>
     * A phone-call or video-conference in which two or more people, who are
     * not in the same room, are actively participating.
     * </pre>
     *
     * <code>PHONE_CALL = 3;</code>
     */
    public static final int PHONE_CALL_VALUE = 3;
    /**
     * <pre>
     * A recorded message intended for another person to listen to.
     * </pre>
     *
     * <code>VOICEMAIL = 4;</code>
     */
    public static final int VOICEMAIL_VALUE = 4;
    /**
     * <pre>
     * Professionally produced audio (eg. TV Show, Podcast).
     * </pre>
     *
     * <code>PROFESSIONALLY_PRODUCED = 5;</code>
     */
    public static final int PROFESSIONALLY_PRODUCED_VALUE = 5;
    /**
     * <pre>
     * Transcribe spoken questions and queries into text.
     * </pre>
     *
     * <code>VOICE_SEARCH = 6;</code>
     */
    public static final int VOICE_SEARCH_VALUE = 6;
    /**
     * <pre>
     * Transcribe voice commands, such as for controlling a device.
     * </pre>
     *
     * <code>VOICE_COMMAND = 7;</code>
     */
    public static final int VOICE_COMMAND_VALUE = 7;
    /**
     * <pre>
     * Transcribe speech to text to create a written document, such as a
     * text-message, email or report.
     * </pre>
     *
     * <code>DICTATION = 8;</code>
     */
    public static final int DICTATION_VALUE = 8;


    @java.lang.Override
    public final int getNumber() {
      if (this == UNRECOGNIZED) {
        throw new java.lang.IllegalArgumentException(
            "Can't get the number of an unknown enum value.");
      }
      return value;
    }

    /**
     * @param value The number of the enum to look for.
     * @return The enum associated with the given number.
     * @deprecated Use {@link #forNumber(int)} instead.
     */
    @java.lang.Deprecated
    public static InteractionType valueOf(int value) {
      return forNumber(value);
    }

    public static InteractionType forNumber(int value) {
      switch (value) {
        case 0: return INTERACTION_TYPE_UNSPECIFIED;
        case 1: return DISCUSSION;
        case 2: return PRESENTATION;
        case 3: return PHONE_CALL;
        case 4: return VOICEMAIL;
        case 5: return PROFESSIONALLY_PRODUCED;
        case 6: return VOICE_SEARCH;
        case 7: return VOICE_COMMAND;
        case 8: return DICTATION;
        default: return null;
      }
    }

    public static com.google.protobuf.Internal.EnumLiteMap<InteractionType>
        internalGetValueMap() {
      return internalValueMap;
    }
    private static final com.google.protobuf.Internal.EnumLiteMap<
        InteractionType> internalValueMap =
          new com.google.protobuf.Internal.EnumLiteMap<InteractionType>() {
            @java.lang.Override
            public InteractionType findValueByNumber(int number) {
              return InteractionType.forNumber(number);
            }
          };

    public static com.google.protobuf.Internal.EnumVerifier 
        internalGetVerifier() {
      return InteractionTypeVerifier.INSTANCE;
    }

    private static final class InteractionTypeVerifier implements 
         com.google.protobuf.Internal.EnumVerifier { 
            static final com.google.protobuf.Internal.EnumVerifier           INSTANCE = new InteractionTypeVerifier();
            @java.lang.Override
            public boolean isInRange(int number) {
              return InteractionType.forNumber(number) != null;
            }
          };

    private final int value;

    private InteractionType(int value) {
      this.value = value;
    }

    // @@protoc_insertion_point(enum_scope:google.cloud.speech.v1.RecognitionMetadata.InteractionType)
  }

  /**
   * <pre>
   * Enumerates the types of capture settings describing an audio file.
   * </pre>
   *
   * Protobuf enum {@code google.cloud.speech.v1.RecognitionMetadata.MicrophoneDistance}
   */
  public enum MicrophoneDistance
      implements com.google.protobuf.Internal.EnumLite {
    /**
     * <pre>
     * Audio type is not known.
     * </pre>
     *
     * <code>MICROPHONE_DISTANCE_UNSPECIFIED = 0;</code>
     */
    MICROPHONE_DISTANCE_UNSPECIFIED(0),
    /**
     * <pre>
     * The audio was captured from a closely placed microphone. Eg. phone,
     * dictaphone, or handheld microphone. Generally if there speaker is within
     * 1 meter of the microphone.
     * </pre>
     *
     * <code>NEARFIELD = 1;</code>
     */
    NEARFIELD(1),
    /**
     * <pre>
     * The speaker if within 3 meters of the microphone.
     * </pre>
     *
     * <code>MIDFIELD = 2;</code>
     */
    MIDFIELD(2),
    /**
     * <pre>
     * The speaker is more than 3 meters away from the microphone.
     * </pre>
     *
     * <code>FARFIELD = 3;</code>
     */
    FARFIELD(3),
    UNRECOGNIZED(-1),
    ;

    /**
     * <pre>
     * Audio type is not known.
     * </pre>
     *
     * <code>MICROPHONE_DISTANCE_UNSPECIFIED = 0;</code>
     */
    public static final int MICROPHONE_DISTANCE_UNSPECIFIED_VALUE = 0;
    /**
     * <pre>
     * The audio was captured from a closely placed microphone. Eg. phone,
     * dictaphone, or handheld microphone. Generally if there speaker is within
     * 1 meter of the microphone.
     * </pre>
     *
     * <code>NEARFIELD = 1;</code>
     */
    public static final int NEARFIELD_VALUE = 1;
    /**
     * <pre>
     * The speaker if within 3 meters of the microphone.
     * </pre>
     *
     * <code>MIDFIELD = 2;</code>
     */
    public static final int MIDFIELD_VALUE = 2;
    /**
     * <pre>
     * The speaker is more than 3 meters away from the microphone.
     * </pre>
     *
     * <code>FARFIELD = 3;</code>
     */
    public static final int FARFIELD_VALUE = 3;


    @java.lang.Override
    public final int getNumber() {
      if (this == UNRECOGNIZED) {
        throw new java.lang.IllegalArgumentException(
            "Can't get the number of an unknown enum value.");
      }
      return value;
    }

    /**
     * @param value The number of the enum to look for.
     * @return The enum associated with the given number.
     * @deprecated Use {@link #forNumber(int)} instead.
     */
    @java.lang.Deprecated
    public static MicrophoneDistance valueOf(int value) {
      return forNumber(value);
    }

    public static MicrophoneDistance forNumber(int value) {
      switch (value) {
        case 0: return MICROPHONE_DISTANCE_UNSPECIFIED;
        case 1: return NEARFIELD;
        case 2: return MIDFIELD;
        case 3: return FARFIELD;
        default: return null;
      }
    }

    public static com.google.protobuf.Internal.EnumLiteMap<MicrophoneDistance>
        internalGetValueMap() {
      return internalValueMap;
    }
    private static final com.google.protobuf.Internal.EnumLiteMap<
        MicrophoneDistance> internalValueMap =
          new com.google.protobuf.Internal.EnumLiteMap<MicrophoneDistance>() {
            @java.lang.Override
            public MicrophoneDistance findValueByNumber(int number) {
              return MicrophoneDistance.forNumber(number);
            }
          };

    public static com.google.protobuf.Internal.EnumVerifier 
        internalGetVerifier() {
      return MicrophoneDistanceVerifier.INSTANCE;
    }

    private static final class MicrophoneDistanceVerifier implements 
         com.google.protobuf.Internal.EnumVerifier { 
            static final com.google.protobuf.Internal.EnumVerifier           INSTANCE = new MicrophoneDistanceVerifier();
            @java.lang.Override
            public boolean isInRange(int number) {
              return MicrophoneDistance.forNumber(number) != null;
            }
          };

    private final int value;

    private MicrophoneDistance(int value) {
      this.value = value;
    }

    // @@protoc_insertion_point(enum_scope:google.cloud.speech.v1.RecognitionMetadata.MicrophoneDistance)
  }

  /**
   * <pre>
   * The original media the speech was recorded on.
   * </pre>
   *
   * Protobuf enum {@code google.cloud.speech.v1.RecognitionMetadata.OriginalMediaType}
   */
  public enum OriginalMediaType
      implements com.google.protobuf.Internal.EnumLite {
    /**
     * <pre>
     * Unknown original media type.
     * </pre>
     *
     * <code>ORIGINAL_MEDIA_TYPE_UNSPECIFIED = 0;</code>
     */
    ORIGINAL_MEDIA_TYPE_UNSPECIFIED(0),
    /**
     * <pre>
     * The speech data is an audio recording.
     * </pre>
     *
     * <code>AUDIO = 1;</code>
     */
    AUDIO(1),
    /**
     * <pre>
     * The speech data originally recorded on a video.
     * </pre>
     *
     * <code>VIDEO = 2;</code>
     */
    VIDEO(2),
    UNRECOGNIZED(-1),
    ;

    /**
     * <pre>
     * Unknown original media type.
     * </pre>
     *
     * <code>ORIGINAL_MEDIA_TYPE_UNSPECIFIED = 0;</code>
     */
    public static final int ORIGINAL_MEDIA_TYPE_UNSPECIFIED_VALUE = 0;
    /**
     * <pre>
     * The speech data is an audio recording.
     * </pre>
     *
     * <code>AUDIO = 1;</code>
     */
    public static final int AUDIO_VALUE = 1;
    /**
     * <pre>
     * The speech data originally recorded on a video.
     * </pre>
     *
     * <code>VIDEO = 2;</code>
     */
    public static final int VIDEO_VALUE = 2;


    @java.lang.Override
    public final int getNumber() {
      if (this == UNRECOGNIZED) {
        throw new java.lang.IllegalArgumentException(
            "Can't get the number of an unknown enum value.");
      }
      return value;
    }

    /**
     * @param value The number of the enum to look for.
     * @return The enum associated with the given number.
     * @deprecated Use {@link #forNumber(int)} instead.
     */
    @java.lang.Deprecated
    public static OriginalMediaType valueOf(int value) {
      return forNumber(value);
    }

    public static OriginalMediaType forNumber(int value) {
      switch (value) {
        case 0: return ORIGINAL_MEDIA_TYPE_UNSPECIFIED;
        case 1: return AUDIO;
        case 2: return VIDEO;
        default: return null;
      }
    }

    public static com.google.protobuf.Internal.EnumLiteMap<OriginalMediaType>
        internalGetValueMap() {
      return internalValueMap;
    }
    private static final com.google.protobuf.Internal.EnumLiteMap<
        OriginalMediaType> internalValueMap =
          new com.google.protobuf.Internal.EnumLiteMap<OriginalMediaType>() {
            @java.lang.Override
            public OriginalMediaType findValueByNumber(int number) {
              return OriginalMediaType.forNumber(number);
            }
          };

    public static com.google.protobuf.Internal.EnumVerifier 
        internalGetVerifier() {
      return OriginalMediaTypeVerifier.INSTANCE;
    }

    private static final class OriginalMediaTypeVerifier implements 
         com.google.protobuf.Internal.EnumVerifier { 
            static final com.google.protobuf.Internal.EnumVerifier           INSTANCE = new OriginalMediaTypeVerifier();
            @java.lang.Override
            public boolean isInRange(int number) {
              return OriginalMediaType.forNumber(number) != null;
            }
          };

    private final int value;

    private OriginalMediaType(int value) {
      this.value = value;
    }

    // @@protoc_insertion_point(enum_scope:google.cloud.speech.v1.RecognitionMetadata.OriginalMediaType)
  }

  /**
   * <pre>
   * The type of device the speech was recorded with.
   * </pre>
   *
   * Protobuf enum {@code google.cloud.speech.v1.RecognitionMetadata.RecordingDeviceType}
   */
  public enum RecordingDeviceType
      implements com.google.protobuf.Internal.EnumLite {
    /**
     * <pre>
     * The recording device is unknown.
     * </pre>
     *
     * <code>RECORDING_DEVICE_TYPE_UNSPECIFIED = 0;</code>
     */
    RECORDING_DEVICE_TYPE_UNSPECIFIED(0),
    /**
     * <pre>
     * Speech was recorded on a smartphone.
     * </pre>
     *
     * <code>SMARTPHONE = 1;</code>
     */
    SMARTPHONE(1),
    /**
     * <pre>
     * Speech was recorded using a personal computer or tablet.
     * </pre>
     *
     * <code>PC = 2;</code>
     */
    PC(2),
    /**
     * <pre>
     * Speech was recorded over a phone line.
     * </pre>
     *
     * <code>PHONE_LINE = 3;</code>
     */
    PHONE_LINE(3),
    /**
     * <pre>
     * Speech was recorded in a vehicle.
     * </pre>
     *
     * <code>VEHICLE = 4;</code>
     */
    VEHICLE(4),
    /**
     * <pre>
     * Speech was recorded outdoors.
     * </pre>
     *
     * <code>OTHER_OUTDOOR_DEVICE = 5;</code>
     */
    OTHER_OUTDOOR_DEVICE(5),
    /**
     * <pre>
     * Speech was recorded indoors.
     * </pre>
     *
     * <code>OTHER_INDOOR_DEVICE = 6;</code>
     */
    OTHER_INDOOR_DEVICE(6),
    UNRECOGNIZED(-1),
    ;

    /**
     * <pre>
     * The recording device is unknown.
     * </pre>
     *
     * <code>RECORDING_DEVICE_TYPE_UNSPECIFIED = 0;</code>
     */
    public static final int RECORDING_DEVICE_TYPE_UNSPECIFIED_VALUE = 0;
    /**
     * <pre>
     * Speech was recorded on a smartphone.
     * </pre>
     *
     * <code>SMARTPHONE = 1;</code>
     */
    public static final int SMARTPHONE_VALUE = 1;
    /**
     * <pre>
     * Speech was recorded using a personal computer or tablet.
     * </pre>
     *
     * <code>PC = 2;</code>
     */
    public static final int PC_VALUE = 2;
    /**
     * <pre>
     * Speech was recorded over a phone line.
     * </pre>
     *
     * <code>PHONE_LINE = 3;</code>
     */
    public static final int PHONE_LINE_VALUE = 3;
    /**
     * <pre>
     * Speech was recorded in a vehicle.
     * </pre>
     *
     * <code>VEHICLE = 4;</code>
     */
    public static final int VEHICLE_VALUE = 4;
    /**
     * <pre>
     * Speech was recorded outdoors.
     * </pre>
     *
     * <code>OTHER_OUTDOOR_DEVICE = 5;</code>
     */
    public static final int OTHER_OUTDOOR_DEVICE_VALUE = 5;
    /**
     * <pre>
     * Speech was recorded indoors.
     * </pre>
     *
     * <code>OTHER_INDOOR_DEVICE = 6;</code>
     */
    public static final int OTHER_INDOOR_DEVICE_VALUE = 6;


    @java.lang.Override
    public final int getNumber() {
      if (this == UNRECOGNIZED) {
        throw new java.lang.IllegalArgumentException(
            "Can't get the number of an unknown enum value.");
      }
      return value;
    }

    /**
     * @param value The number of the enum to look for.
     * @return The enum associated with the given number.
     * @deprecated Use {@link #forNumber(int)} instead.
     */
    @java.lang.Deprecated
    public static RecordingDeviceType valueOf(int value) {
      return forNumber(value);
    }

    public static RecordingDeviceType forNumber(int value) {
      switch (value) {
        case 0: return RECORDING_DEVICE_TYPE_UNSPECIFIED;
        case 1: return SMARTPHONE;
        case 2: return PC;
        case 3: return PHONE_LINE;
        case 4: return VEHICLE;
        case 5: return OTHER_OUTDOOR_DEVICE;
        case 6: return OTHER_INDOOR_DEVICE;
        default: return null;
      }
    }

    public static com.google.protobuf.Internal.EnumLiteMap<RecordingDeviceType>
        internalGetValueMap() {
      return internalValueMap;
    }
    private static final com.google.protobuf.Internal.EnumLiteMap<
        RecordingDeviceType> internalValueMap =
          new com.google.protobuf.Internal.EnumLiteMap<RecordingDeviceType>() {
            @java.lang.Override
            public RecordingDeviceType findValueByNumber(int number) {
              return RecordingDeviceType.forNumber(number);
            }
          };

    public static com.google.protobuf.Internal.EnumVerifier 
        internalGetVerifier() {
      return RecordingDeviceTypeVerifier.INSTANCE;
    }

    private static final class RecordingDeviceTypeVerifier implements 
         com.google.protobuf.Internal.EnumVerifier { 
            static final com.google.protobuf.Internal.EnumVerifier           INSTANCE = new RecordingDeviceTypeVerifier();
            @java.lang.Override
            public boolean isInRange(int number) {
              return RecordingDeviceType.forNumber(number) != null;
            }
          };

    private final int value;

    private RecordingDeviceType(int value) {
      this.value = value;
    }

    // @@protoc_insertion_point(enum_scope:google.cloud.speech.v1.RecognitionMetadata.RecordingDeviceType)
  }

  public static final int INTERACTION_TYPE_FIELD_NUMBER = 1;
  private int interactionType_;
  /**
   * <pre>
   * The use case most closely describing the audio content to be recognized.
   * </pre>
   *
   * <code>.google.cloud.speech.v1.RecognitionMetadata.InteractionType interaction_type = 1;</code>
   * @return The enum numeric value on the wire for interactionType.
   */
  @java.lang.Override
  public int getInteractionTypeValue() {
    return interactionType_;
  }
  /**
   * <pre>
   * The use case most closely describing the audio content to be recognized.
   * </pre>
   *
   * <code>.google.cloud.speech.v1.RecognitionMetadata.InteractionType interaction_type = 1;</code>
   * @return The interactionType.
   */
  @java.lang.Override
  public com.google.cloud.speech.v1.RecognitionMetadata.InteractionType getInteractionType() {
    com.google.cloud.speech.v1.RecognitionMetadata.InteractionType result = com.google.cloud.speech.v1.RecognitionMetadata.InteractionType.forNumber(interactionType_);
    return result == null ? com.google.cloud.speech.v1.RecognitionMetadata.InteractionType.UNRECOGNIZED : result;
  }
  /**
   * <pre>
   * The use case most closely describing the audio content to be recognized.
   * </pre>
   *
   * <code>.google.cloud.speech.v1.RecognitionMetadata.InteractionType interaction_type = 1;</code>
   * @param value The enum numeric value on the wire for interactionType to set.
   */
  private void setInteractionTypeValue(int value) {
      interactionType_ = value;
  }
  /**
   * <pre>
   * The use case most closely describing the audio content to be recognized.
   * </pre>
   *
   * <code>.google.cloud.speech.v1.RecognitionMetadata.InteractionType interaction_type = 1;</code>
   * @param value The interactionType to set.
   */
  private void setInteractionType(com.google.cloud.speech.v1.RecognitionMetadata.InteractionType value) {
    interactionType_ = value.getNumber();
    
  }
  /**
   * <pre>
   * The use case most closely describing the audio content to be recognized.
   * </pre>
   *
   * <code>.google.cloud.speech.v1.RecognitionMetadata.InteractionType interaction_type = 1;</code>
   */
  private void clearInteractionType() {
    
    interactionType_ = 0;
  }

  public static final int INDUSTRY_NAICS_CODE_OF_AUDIO_FIELD_NUMBER = 3;
  private int industryNaicsCodeOfAudio_;
  /**
   * <pre>
   * The industry vertical to which this speech recognition request most
   * closely applies. This is most indicative of the topics contained
   * in the audio.  Use the 6-digit NAICS code to identify the industry
   * vertical - see https://www.naics.com/search/.
   * </pre>
   *
   * <code>uint32 industry_naics_code_of_audio = 3;</code>
   * @return The industryNaicsCodeOfAudio.
   */
  @java.lang.Override
  public int getIndustryNaicsCodeOfAudio() {
    return industryNaicsCodeOfAudio_;
  }
  /**
   * <pre>
   * The industry vertical to which this speech recognition request most
   * closely applies. This is most indicative of the topics contained
   * in the audio.  Use the 6-digit NAICS code to identify the industry
   * vertical - see https://www.naics.com/search/.
   * </pre>
   *
   * <code>uint32 industry_naics_code_of_audio = 3;</code>
   * @param value The industryNaicsCodeOfAudio to set.
   */
  private void setIndustryNaicsCodeOfAudio(int value) {
    
    industryNaicsCodeOfAudio_ = value;
  }
  /**
   * <pre>
   * The industry vertical to which this speech recognition request most
   * closely applies. This is most indicative of the topics contained
   * in the audio.  Use the 6-digit NAICS code to identify the industry
   * vertical - see https://www.naics.com/search/.
   * </pre>
   *
   * <code>uint32 industry_naics_code_of_audio = 3;</code>
   */
  private void clearIndustryNaicsCodeOfAudio() {
    
    industryNaicsCodeOfAudio_ = 0;
  }

  public static final int MICROPHONE_DISTANCE_FIELD_NUMBER = 4;
  private int microphoneDistance_;
  /**
   * <pre>
   * The audio type that most closely describes the audio being recognized.
   * </pre>
   *
   * <code>.google.cloud.speech.v1.RecognitionMetadata.MicrophoneDistance microphone_distance = 4;</code>
   * @return The enum numeric value on the wire for microphoneDistance.
   */
  @java.lang.Override
  public int getMicrophoneDistanceValue() {
    return microphoneDistance_;
  }
  /**
   * <pre>
   * The audio type that most closely describes the audio being recognized.
   * </pre>
   *
   * <code>.google.cloud.speech.v1.RecognitionMetadata.MicrophoneDistance microphone_distance = 4;</code>
   * @return The microphoneDistance.
   */
  @java.lang.Override
  public com.google.cloud.speech.v1.RecognitionMetadata.MicrophoneDistance getMicrophoneDistance() {
    com.google.cloud.speech.v1.RecognitionMetadata.MicrophoneDistance result = com.google.cloud.speech.v1.RecognitionMetadata.MicrophoneDistance.forNumber(microphoneDistance_);
    return result == null ? com.google.cloud.speech.v1.RecognitionMetadata.MicrophoneDistance.UNRECOGNIZED : result;
  }
  /**
   * <pre>
   * The audio type that most closely describes the audio being recognized.
   * </pre>
   *
   * <code>.google.cloud.speech.v1.RecognitionMetadata.MicrophoneDistance microphone_distance = 4;</code>
   * @param value The enum numeric value on the wire for microphoneDistance to set.
   */
  private void setMicrophoneDistanceValue(int value) {
      microphoneDistance_ = value;
  }
  /**
   * <pre>
   * The audio type that most closely describes the audio being recognized.
   * </pre>
   *
   * <code>.google.cloud.speech.v1.RecognitionMetadata.MicrophoneDistance microphone_distance = 4;</code>
   * @param value The microphoneDistance to set.
   */
  private void setMicrophoneDistance(com.google.cloud.speech.v1.RecognitionMetadata.MicrophoneDistance value) {
    microphoneDistance_ = value.getNumber();
    
  }
  /**
   * <pre>
   * The audio type that most closely describes the audio being recognized.
   * </pre>
   *
   * <code>.google.cloud.speech.v1.RecognitionMetadata.MicrophoneDistance microphone_distance = 4;</code>
   */
  private void clearMicrophoneDistance() {
    
    microphoneDistance_ = 0;
  }

  public static final int ORIGINAL_MEDIA_TYPE_FIELD_NUMBER = 5;
  private int originalMediaType_;
  /**
   * <pre>
   * The original media the speech was recorded on.
   * </pre>
   *
   * <code>.google.cloud.speech.v1.RecognitionMetadata.OriginalMediaType original_media_type = 5;</code>
   * @return The enum numeric value on the wire for originalMediaType.
   */
  @java.lang.Override
  public int getOriginalMediaTypeValue() {
    return originalMediaType_;
  }
  /**
   * <pre>
   * The original media the speech was recorded on.
   * </pre>
   *
   * <code>.google.cloud.speech.v1.RecognitionMetadata.OriginalMediaType original_media_type = 5;</code>
   * @return The originalMediaType.
   */
  @java.lang.Override
  public com.google.cloud.speech.v1.RecognitionMetadata.OriginalMediaType getOriginalMediaType() {
    com.google.cloud.speech.v1.RecognitionMetadata.OriginalMediaType result = com.google.cloud.speech.v1.RecognitionMetadata.OriginalMediaType.forNumber(originalMediaType_);
    return result == null ? com.google.cloud.speech.v1.RecognitionMetadata.OriginalMediaType.UNRECOGNIZED : result;
  }
  /**
   * <pre>
   * The original media the speech was recorded on.
   * </pre>
   *
   * <code>.google.cloud.speech.v1.RecognitionMetadata.OriginalMediaType original_media_type = 5;</code>
   * @param value The enum numeric value on the wire for originalMediaType to set.
   */
  private void setOriginalMediaTypeValue(int value) {
      originalMediaType_ = value;
  }
  /**
   * <pre>
   * The original media the speech was recorded on.
   * </pre>
   *
   * <code>.google.cloud.speech.v1.RecognitionMetadata.OriginalMediaType original_media_type = 5;</code>
   * @param value The originalMediaType to set.
   */
  private void setOriginalMediaType(com.google.cloud.speech.v1.RecognitionMetadata.OriginalMediaType value) {
    originalMediaType_ = value.getNumber();
    
  }
  /**
   * <pre>
   * The original media the speech was recorded on.
   * </pre>
   *
   * <code>.google.cloud.speech.v1.RecognitionMetadata.OriginalMediaType original_media_type = 5;</code>
   */
  private void clearOriginalMediaType() {
    
    originalMediaType_ = 0;
  }

  public static final int RECORDING_DEVICE_TYPE_FIELD_NUMBER = 6;
  private int recordingDeviceType_;
  /**
   * <pre>
   * The type of device the speech was recorded with.
   * </pre>
   *
   * <code>.google.cloud.speech.v1.RecognitionMetadata.RecordingDeviceType recording_device_type = 6;</code>
   * @return The enum numeric value on the wire for recordingDeviceType.
   */
  @java.lang.Override
  public int getRecordingDeviceTypeValue() {
    return recordingDeviceType_;
  }
  /**
   * <pre>
   * The type of device the speech was recorded with.
   * </pre>
   *
   * <code>.google.cloud.speech.v1.RecognitionMetadata.RecordingDeviceType recording_device_type = 6;</code>
   * @return The recordingDeviceType.
   */
  @java.lang.Override
  public com.google.cloud.speech.v1.RecognitionMetadata.RecordingDeviceType getRecordingDeviceType() {
    com.google.cloud.speech.v1.RecognitionMetadata.RecordingDeviceType result = com.google.cloud.speech.v1.RecognitionMetadata.RecordingDeviceType.forNumber(recordingDeviceType_);
    return result == null ? com.google.cloud.speech.v1.RecognitionMetadata.RecordingDeviceType.UNRECOGNIZED : result;
  }
  /**
   * <pre>
   * The type of device the speech was recorded with.
   * </pre>
   *
   * <code>.google.cloud.speech.v1.RecognitionMetadata.RecordingDeviceType recording_device_type = 6;</code>
   * @param value The enum numeric value on the wire for recordingDeviceType to set.
   */
  private void setRecordingDeviceTypeValue(int value) {
      recordingDeviceType_ = value;
  }
  /**
   * <pre>
   * The type of device the speech was recorded with.
   * </pre>
   *
   * <code>.google.cloud.speech.v1.RecognitionMetadata.RecordingDeviceType recording_device_type = 6;</code>
   * @param value The recordingDeviceType to set.
   */
  private void setRecordingDeviceType(com.google.cloud.speech.v1.RecognitionMetadata.RecordingDeviceType value) {
    recordingDeviceType_ = value.getNumber();
    
  }
  /**
   * <pre>
   * The type of device the speech was recorded with.
   * </pre>
   *
   * <code>.google.cloud.speech.v1.RecognitionMetadata.RecordingDeviceType recording_device_type = 6;</code>
   */
  private void clearRecordingDeviceType() {
    
    recordingDeviceType_ = 0;
  }

  public static final int RECORDING_DEVICE_NAME_FIELD_NUMBER = 7;
  private java.lang.String recordingDeviceName_;
  /**
   * <pre>
   * The device used to make the recording.  Examples 'Nexus 5X' or
   * 'Polycom SoundStation IP 6000' or 'POTS' or 'VoIP' or
   * 'Cardioid Microphone'.
   * </pre>
   *
   * <code>string recording_device_name = 7;</code>
   * @return The recordingDeviceName.
   */
  @java.lang.Override
  public java.lang.String getRecordingDeviceName() {
    return recordingDeviceName_;
  }
  /**
   * <pre>
   * The device used to make the recording.  Examples 'Nexus 5X' or
   * 'Polycom SoundStation IP 6000' or 'POTS' or 'VoIP' or
   * 'Cardioid Microphone'.
   * </pre>
   *
   * <code>string recording_device_name = 7;</code>
   * @return The bytes for recordingDeviceName.
   */
  @java.lang.Override
  public com.google.protobuf.ByteString
      getRecordingDeviceNameBytes() {
    return com.google.protobuf.ByteString.copyFromUtf8(recordingDeviceName_);
  }
  /**
   * <pre>
   * The device used to make the recording.  Examples 'Nexus 5X' or
   * 'Polycom SoundStation IP 6000' or 'POTS' or 'VoIP' or
   * 'Cardioid Microphone'.
   * </pre>
   *
   * <code>string recording_device_name = 7;</code>
   * @param value The recordingDeviceName to set.
   */
  private void setRecordingDeviceName(
      java.lang.String value) {
    value.getClass();
  
    recordingDeviceName_ = value;
  }
  /**
   * <pre>
   * The device used to make the recording.  Examples 'Nexus 5X' or
   * 'Polycom SoundStation IP 6000' or 'POTS' or 'VoIP' or
   * 'Cardioid Microphone'.
   * </pre>
   *
   * <code>string recording_device_name = 7;</code>
   */
  private void clearRecordingDeviceName() {
    
    recordingDeviceName_ = getDefaultInstance().getRecordingDeviceName();
  }
  /**
   * <pre>
   * The device used to make the recording.  Examples 'Nexus 5X' or
   * 'Polycom SoundStation IP 6000' or 'POTS' or 'VoIP' or
   * 'Cardioid Microphone'.
   * </pre>
   *
   * <code>string recording_device_name = 7;</code>
   * @param value The bytes for recordingDeviceName to set.
   */
  private void setRecordingDeviceNameBytes(
      com.google.protobuf.ByteString value) {
    checkByteStringIsUtf8(value);
    recordingDeviceName_ = value.toStringUtf8();
    
  }

  public static final int ORIGINAL_MIME_TYPE_FIELD_NUMBER = 8;
  private java.lang.String originalMimeType_;
  /**
   * <pre>
   * Mime type of the original audio file.  For example `audio/m4a`,
   * `audio/x-alaw-basic`, `audio/mp3`, `audio/3gpp`.
   * A list of possible audio mime types is maintained at
   * http://www.iana.org/assignments/media-types/media-types.xhtml#audio
   * </pre>
   *
   * <code>string original_mime_type = 8;</code>
   * @return The originalMimeType.
   */
  @java.lang.Override
  public java.lang.String getOriginalMimeType() {
    return originalMimeType_;
  }
  /**
   * <pre>
   * Mime type of the original audio file.  For example `audio/m4a`,
   * `audio/x-alaw-basic`, `audio/mp3`, `audio/3gpp`.
   * A list of possible audio mime types is maintained at
   * http://www.iana.org/assignments/media-types/media-types.xhtml#audio
   * </pre>
   *
   * <code>string original_mime_type = 8;</code>
   * @return The bytes for originalMimeType.
   */
  @java.lang.Override
  public com.google.protobuf.ByteString
      getOriginalMimeTypeBytes() {
    return com.google.protobuf.ByteString.copyFromUtf8(originalMimeType_);
  }
  /**
   * <pre>
   * Mime type of the original audio file.  For example `audio/m4a`,
   * `audio/x-alaw-basic`, `audio/mp3`, `audio/3gpp`.
   * A list of possible audio mime types is maintained at
   * http://www.iana.org/assignments/media-types/media-types.xhtml#audio
   * </pre>
   *
   * <code>string original_mime_type = 8;</code>
   * @param value The originalMimeType to set.
   */
  private void setOriginalMimeType(
      java.lang.String value) {
    value.getClass();
  
    originalMimeType_ = value;
  }
  /**
   * <pre>
   * Mime type of the original audio file.  For example `audio/m4a`,
   * `audio/x-alaw-basic`, `audio/mp3`, `audio/3gpp`.
   * A list of possible audio mime types is maintained at
   * http://www.iana.org/assignments/media-types/media-types.xhtml#audio
   * </pre>
   *
   * <code>string original_mime_type = 8;</code>
   */
  private void clearOriginalMimeType() {
    
    originalMimeType_ = getDefaultInstance().getOriginalMimeType();
  }
  /**
   * <pre>
   * Mime type of the original audio file.  For example `audio/m4a`,
   * `audio/x-alaw-basic`, `audio/mp3`, `audio/3gpp`.
   * A list of possible audio mime types is maintained at
   * http://www.iana.org/assignments/media-types/media-types.xhtml#audio
   * </pre>
   *
   * <code>string original_mime_type = 8;</code>
   * @param value The bytes for originalMimeType to set.
   */
  private void setOriginalMimeTypeBytes(
      com.google.protobuf.ByteString value) {
    checkByteStringIsUtf8(value);
    originalMimeType_ = value.toStringUtf8();
    
  }

  public static final int AUDIO_TOPIC_FIELD_NUMBER = 10;
  private java.lang.String audioTopic_;
  /**
   * <pre>
   * Description of the content. Eg. "Recordings of federal supreme court
   * hearings from 2012".
   * </pre>
   *
   * <code>string audio_topic = 10;</code>
   * @return The audioTopic.
   */
  @java.lang.Override
  public java.lang.String getAudioTopic() {
    return audioTopic_;
  }
  /**
   * <pre>
   * Description of the content. Eg. "Recordings of federal supreme court
   * hearings from 2012".
   * </pre>
   *
   * <code>string audio_topic = 10;</code>
   * @return The bytes for audioTopic.
   */
  @java.lang.Override
  public com.google.protobuf.ByteString
      getAudioTopicBytes() {
    return com.google.protobuf.ByteString.copyFromUtf8(audioTopic_);
  }
  /**
   * <pre>
   * Description of the content. Eg. "Recordings of federal supreme court
   * hearings from 2012".
   * </pre>
   *
   * <code>string audio_topic = 10;</code>
   * @param value The audioTopic to set.
   */
  private void setAudioTopic(
      java.lang.String value) {
    value.getClass();
  
    audioTopic_ = value;
  }
  /**
   * <pre>
   * Description of the content. Eg. "Recordings of federal supreme court
   * hearings from 2012".
   * </pre>
   *
   * <code>string audio_topic = 10;</code>
   */
  private void clearAudioTopic() {
    
    audioTopic_ = getDefaultInstance().getAudioTopic();
  }
  /**
   * <pre>
   * Description of the content. Eg. "Recordings of federal supreme court
   * hearings from 2012".
   * </pre>
   *
   * <code>string audio_topic = 10;</code>
   * @param value The bytes for audioTopic to set.
   */
  private void setAudioTopicBytes(
      com.google.protobuf.ByteString value) {
    checkByteStringIsUtf8(value);
    audioTopic_ = value.toStringUtf8();
    
  }

  public static com.google.cloud.speech.v1.RecognitionMetadata parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data);
  }
  public static com.google.cloud.speech.v1.RecognitionMetadata parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data, extensionRegistry);
  }
  public static com.google.cloud.speech.v1.RecognitionMetadata parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data);
  }
  public static com.google.cloud.speech.v1.RecognitionMetadata parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data, extensionRegistry);
  }
  public static com.google.cloud.speech.v1.RecognitionMetadata parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data);
  }
  public static com.google.cloud.speech.v1.RecognitionMetadata parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data, extensionRegistry);
  }
  public static com.google.cloud.speech.v1.RecognitionMetadata parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input);
  }
  public static com.google.cloud.speech.v1.RecognitionMetadata parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input, extensionRegistry);
  }
  public static com.google.cloud.speech.v1.RecognitionMetadata parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return parseDelimitedFrom(DEFAULT_INSTANCE, input);
  }
  public static com.google.cloud.speech.v1.RecognitionMetadata parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return parseDelimitedFrom(DEFAULT_INSTANCE, input, extensionRegistry);
  }
  public static com.google.cloud.speech.v1.RecognitionMetadata parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input);
  }
  public static com.google.cloud.speech.v1.RecognitionMetadata parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input, extensionRegistry);
  }

  public static Builder newBuilder() {
    return (Builder) DEFAULT_INSTANCE.createBuilder();
  }
  public static Builder newBuilder(com.google.cloud.speech.v1.RecognitionMetadata prototype) {
    return (Builder) DEFAULT_INSTANCE.createBuilder(prototype);
  }

  /**
   * <pre>
   * Description of audio data to be recognized.
   * </pre>
   *
   * Protobuf type {@code google.cloud.speech.v1.RecognitionMetadata}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageLite.Builder<
        com.google.cloud.speech.v1.RecognitionMetadata, Builder> implements
      // @@protoc_insertion_point(builder_implements:google.cloud.speech.v1.RecognitionMetadata)
      com.google.cloud.speech.v1.RecognitionMetadataOrBuilder {
    // Construct using com.google.cloud.speech.v1.RecognitionMetadata.newBuilder()
    private Builder() {
      super(DEFAULT_INSTANCE);
    }


    /**
     * <pre>
     * The use case most closely describing the audio content to be recognized.
     * </pre>
     *
     * <code>.google.cloud.speech.v1.RecognitionMetadata.InteractionType interaction_type = 1;</code>
     * @return The enum numeric value on the wire for interactionType.
     */
    @java.lang.Override
    public int getInteractionTypeValue() {
      return instance.getInteractionTypeValue();
    }
    /**
     * <pre>
     * The use case most closely describing the audio content to be recognized.
     * </pre>
     *
     * <code>.google.cloud.speech.v1.RecognitionMetadata.InteractionType interaction_type = 1;</code>
     * @param value The interactionType to set.
     * @return This builder for chaining.
     */
    public Builder setInteractionTypeValue(int value) {
      copyOnWrite();
      instance.setInteractionTypeValue(value);
      return this;
    }
    /**
     * <pre>
     * The use case most closely describing the audio content to be recognized.
     * </pre>
     *
     * <code>.google.cloud.speech.v1.RecognitionMetadata.InteractionType interaction_type = 1;</code>
     * @return The interactionType.
     */
    @java.lang.Override
    public com.google.cloud.speech.v1.RecognitionMetadata.InteractionType getInteractionType() {
      return instance.getInteractionType();
    }
    /**
     * <pre>
     * The use case most closely describing the audio content to be recognized.
     * </pre>
     *
     * <code>.google.cloud.speech.v1.RecognitionMetadata.InteractionType interaction_type = 1;</code>
     * @param value The enum numeric value on the wire for interactionType to set.
     * @return This builder for chaining.
     */
    public Builder setInteractionType(com.google.cloud.speech.v1.RecognitionMetadata.InteractionType value) {
      copyOnWrite();
      instance.setInteractionType(value);
      return this;
    }
    /**
     * <pre>
     * The use case most closely describing the audio content to be recognized.
     * </pre>
     *
     * <code>.google.cloud.speech.v1.RecognitionMetadata.InteractionType interaction_type = 1;</code>
     * @return This builder for chaining.
     */
    public Builder clearInteractionType() {
      copyOnWrite();
      instance.clearInteractionType();
      return this;
    }

    /**
     * <pre>
     * The industry vertical to which this speech recognition request most
     * closely applies. This is most indicative of the topics contained
     * in the audio.  Use the 6-digit NAICS code to identify the industry
     * vertical - see https://www.naics.com/search/.
     * </pre>
     *
     * <code>uint32 industry_naics_code_of_audio = 3;</code>
     * @return The industryNaicsCodeOfAudio.
     */
    @java.lang.Override
    public int getIndustryNaicsCodeOfAudio() {
      return instance.getIndustryNaicsCodeOfAudio();
    }
    /**
     * <pre>
     * The industry vertical to which this speech recognition request most
     * closely applies. This is most indicative of the topics contained
     * in the audio.  Use the 6-digit NAICS code to identify the industry
     * vertical - see https://www.naics.com/search/.
     * </pre>
     *
     * <code>uint32 industry_naics_code_of_audio = 3;</code>
     * @param value The industryNaicsCodeOfAudio to set.
     * @return This builder for chaining.
     */
    public Builder setIndustryNaicsCodeOfAudio(int value) {
      copyOnWrite();
      instance.setIndustryNaicsCodeOfAudio(value);
      return this;
    }
    /**
     * <pre>
     * The industry vertical to which this speech recognition request most
     * closely applies. This is most indicative of the topics contained
     * in the audio.  Use the 6-digit NAICS code to identify the industry
     * vertical - see https://www.naics.com/search/.
     * </pre>
     *
     * <code>uint32 industry_naics_code_of_audio = 3;</code>
     * @return This builder for chaining.
     */
    public Builder clearIndustryNaicsCodeOfAudio() {
      copyOnWrite();
      instance.clearIndustryNaicsCodeOfAudio();
      return this;
    }

    /**
     * <pre>
     * The audio type that most closely describes the audio being recognized.
     * </pre>
     *
     * <code>.google.cloud.speech.v1.RecognitionMetadata.MicrophoneDistance microphone_distance = 4;</code>
     * @return The enum numeric value on the wire for microphoneDistance.
     */
    @java.lang.Override
    public int getMicrophoneDistanceValue() {
      return instance.getMicrophoneDistanceValue();
    }
    /**
     * <pre>
     * The audio type that most closely describes the audio being recognized.
     * </pre>
     *
     * <code>.google.cloud.speech.v1.RecognitionMetadata.MicrophoneDistance microphone_distance = 4;</code>
     * @param value The microphoneDistance to set.
     * @return This builder for chaining.
     */
    public Builder setMicrophoneDistanceValue(int value) {
      copyOnWrite();
      instance.setMicrophoneDistanceValue(value);
      return this;
    }
    /**
     * <pre>
     * The audio type that most closely describes the audio being recognized.
     * </pre>
     *
     * <code>.google.cloud.speech.v1.RecognitionMetadata.MicrophoneDistance microphone_distance = 4;</code>
     * @return The microphoneDistance.
     */
    @java.lang.Override
    public com.google.cloud.speech.v1.RecognitionMetadata.MicrophoneDistance getMicrophoneDistance() {
      return instance.getMicrophoneDistance();
    }
    /**
     * <pre>
     * The audio type that most closely describes the audio being recognized.
     * </pre>
     *
     * <code>.google.cloud.speech.v1.RecognitionMetadata.MicrophoneDistance microphone_distance = 4;</code>
     * @param value The enum numeric value on the wire for microphoneDistance to set.
     * @return This builder for chaining.
     */
    public Builder setMicrophoneDistance(com.google.cloud.speech.v1.RecognitionMetadata.MicrophoneDistance value) {
      copyOnWrite();
      instance.setMicrophoneDistance(value);
      return this;
    }
    /**
     * <pre>
     * The audio type that most closely describes the audio being recognized.
     * </pre>
     *
     * <code>.google.cloud.speech.v1.RecognitionMetadata.MicrophoneDistance microphone_distance = 4;</code>
     * @return This builder for chaining.
     */
    public Builder clearMicrophoneDistance() {
      copyOnWrite();
      instance.clearMicrophoneDistance();
      return this;
    }

    /**
     * <pre>
     * The original media the speech was recorded on.
     * </pre>
     *
     * <code>.google.cloud.speech.v1.RecognitionMetadata.OriginalMediaType original_media_type = 5;</code>
     * @return The enum numeric value on the wire for originalMediaType.
     */
    @java.lang.Override
    public int getOriginalMediaTypeValue() {
      return instance.getOriginalMediaTypeValue();
    }
    /**
     * <pre>
     * The original media the speech was recorded on.
     * </pre>
     *
     * <code>.google.cloud.speech.v1.RecognitionMetadata.OriginalMediaType original_media_type = 5;</code>
     * @param value The originalMediaType to set.
     * @return This builder for chaining.
     */
    public Builder setOriginalMediaTypeValue(int value) {
      copyOnWrite();
      instance.setOriginalMediaTypeValue(value);
      return this;
    }
    /**
     * <pre>
     * The original media the speech was recorded on.
     * </pre>
     *
     * <code>.google.cloud.speech.v1.RecognitionMetadata.OriginalMediaType original_media_type = 5;</code>
     * @return The originalMediaType.
     */
    @java.lang.Override
    public com.google.cloud.speech.v1.RecognitionMetadata.OriginalMediaType getOriginalMediaType() {
      return instance.getOriginalMediaType();
    }
    /**
     * <pre>
     * The original media the speech was recorded on.
     * </pre>
     *
     * <code>.google.cloud.speech.v1.RecognitionMetadata.OriginalMediaType original_media_type = 5;</code>
     * @param value The enum numeric value on the wire for originalMediaType to set.
     * @return This builder for chaining.
     */
    public Builder setOriginalMediaType(com.google.cloud.speech.v1.RecognitionMetadata.OriginalMediaType value) {
      copyOnWrite();
      instance.setOriginalMediaType(value);
      return this;
    }
    /**
     * <pre>
     * The original media the speech was recorded on.
     * </pre>
     *
     * <code>.google.cloud.speech.v1.RecognitionMetadata.OriginalMediaType original_media_type = 5;</code>
     * @return This builder for chaining.
     */
    public Builder clearOriginalMediaType() {
      copyOnWrite();
      instance.clearOriginalMediaType();
      return this;
    }

    /**
     * <pre>
     * The type of device the speech was recorded with.
     * </pre>
     *
     * <code>.google.cloud.speech.v1.RecognitionMetadata.RecordingDeviceType recording_device_type = 6;</code>
     * @return The enum numeric value on the wire for recordingDeviceType.
     */
    @java.lang.Override
    public int getRecordingDeviceTypeValue() {
      return instance.getRecordingDeviceTypeValue();
    }
    /**
     * <pre>
     * The type of device the speech was recorded with.
     * </pre>
     *
     * <code>.google.cloud.speech.v1.RecognitionMetadata.RecordingDeviceType recording_device_type = 6;</code>
     * @param value The recordingDeviceType to set.
     * @return This builder for chaining.
     */
    public Builder setRecordingDeviceTypeValue(int value) {
      copyOnWrite();
      instance.setRecordingDeviceTypeValue(value);
      return this;
    }
    /**
     * <pre>
     * The type of device the speech was recorded with.
     * </pre>
     *
     * <code>.google.cloud.speech.v1.RecognitionMetadata.RecordingDeviceType recording_device_type = 6;</code>
     * @return The recordingDeviceType.
     */
    @java.lang.Override
    public com.google.cloud.speech.v1.RecognitionMetadata.RecordingDeviceType getRecordingDeviceType() {
      return instance.getRecordingDeviceType();
    }
    /**
     * <pre>
     * The type of device the speech was recorded with.
     * </pre>
     *
     * <code>.google.cloud.speech.v1.RecognitionMetadata.RecordingDeviceType recording_device_type = 6;</code>
     * @param value The enum numeric value on the wire for recordingDeviceType to set.
     * @return This builder for chaining.
     */
    public Builder setRecordingDeviceType(com.google.cloud.speech.v1.RecognitionMetadata.RecordingDeviceType value) {
      copyOnWrite();
      instance.setRecordingDeviceType(value);
      return this;
    }
    /**
     * <pre>
     * The type of device the speech was recorded with.
     * </pre>
     *
     * <code>.google.cloud.speech.v1.RecognitionMetadata.RecordingDeviceType recording_device_type = 6;</code>
     * @return This builder for chaining.
     */
    public Builder clearRecordingDeviceType() {
      copyOnWrite();
      instance.clearRecordingDeviceType();
      return this;
    }

    /**
     * <pre>
     * The device used to make the recording.  Examples 'Nexus 5X' or
     * 'Polycom SoundStation IP 6000' or 'POTS' or 'VoIP' or
     * 'Cardioid Microphone'.
     * </pre>
     *
     * <code>string recording_device_name = 7;</code>
     * @return The recordingDeviceName.
     */
    @java.lang.Override
    public java.lang.String getRecordingDeviceName() {
      return instance.getRecordingDeviceName();
    }
    /**
     * <pre>
     * The device used to make the recording.  Examples 'Nexus 5X' or
     * 'Polycom SoundStation IP 6000' or 'POTS' or 'VoIP' or
     * 'Cardioid Microphone'.
     * </pre>
     *
     * <code>string recording_device_name = 7;</code>
     * @return The bytes for recordingDeviceName.
     */
    @java.lang.Override
    public com.google.protobuf.ByteString
        getRecordingDeviceNameBytes() {
      return instance.getRecordingDeviceNameBytes();
    }
    /**
     * <pre>
     * The device used to make the recording.  Examples 'Nexus 5X' or
     * 'Polycom SoundStation IP 6000' or 'POTS' or 'VoIP' or
     * 'Cardioid Microphone'.
     * </pre>
     *
     * <code>string recording_device_name = 7;</code>
     * @param value The recordingDeviceName to set.
     * @return This builder for chaining.
     */
    public Builder setRecordingDeviceName(
        java.lang.String value) {
      copyOnWrite();
      instance.setRecordingDeviceName(value);
      return this;
    }
    /**
     * <pre>
     * The device used to make the recording.  Examples 'Nexus 5X' or
     * 'Polycom SoundStation IP 6000' or 'POTS' or 'VoIP' or
     * 'Cardioid Microphone'.
     * </pre>
     *
     * <code>string recording_device_name = 7;</code>
     * @return This builder for chaining.
     */
    public Builder clearRecordingDeviceName() {
      copyOnWrite();
      instance.clearRecordingDeviceName();
      return this;
    }
    /**
     * <pre>
     * The device used to make the recording.  Examples 'Nexus 5X' or
     * 'Polycom SoundStation IP 6000' or 'POTS' or 'VoIP' or
     * 'Cardioid Microphone'.
     * </pre>
     *
     * <code>string recording_device_name = 7;</code>
     * @param value The bytes for recordingDeviceName to set.
     * @return This builder for chaining.
     */
    public Builder setRecordingDeviceNameBytes(
        com.google.protobuf.ByteString value) {
      copyOnWrite();
      instance.setRecordingDeviceNameBytes(value);
      return this;
    }

    /**
     * <pre>
     * Mime type of the original audio file.  For example `audio/m4a`,
     * `audio/x-alaw-basic`, `audio/mp3`, `audio/3gpp`.
     * A list of possible audio mime types is maintained at
     * http://www.iana.org/assignments/media-types/media-types.xhtml#audio
     * </pre>
     *
     * <code>string original_mime_type = 8;</code>
     * @return The originalMimeType.
     */
    @java.lang.Override
    public java.lang.String getOriginalMimeType() {
      return instance.getOriginalMimeType();
    }
    /**
     * <pre>
     * Mime type of the original audio file.  For example `audio/m4a`,
     * `audio/x-alaw-basic`, `audio/mp3`, `audio/3gpp`.
     * A list of possible audio mime types is maintained at
     * http://www.iana.org/assignments/media-types/media-types.xhtml#audio
     * </pre>
     *
     * <code>string original_mime_type = 8;</code>
     * @return The bytes for originalMimeType.
     */
    @java.lang.Override
    public com.google.protobuf.ByteString
        getOriginalMimeTypeBytes() {
      return instance.getOriginalMimeTypeBytes();
    }
    /**
     * <pre>
     * Mime type of the original audio file.  For example `audio/m4a`,
     * `audio/x-alaw-basic`, `audio/mp3`, `audio/3gpp`.
     * A list of possible audio mime types is maintained at
     * http://www.iana.org/assignments/media-types/media-types.xhtml#audio
     * </pre>
     *
     * <code>string original_mime_type = 8;</code>
     * @param value The originalMimeType to set.
     * @return This builder for chaining.
     */
    public Builder setOriginalMimeType(
        java.lang.String value) {
      copyOnWrite();
      instance.setOriginalMimeType(value);
      return this;
    }
    /**
     * <pre>
     * Mime type of the original audio file.  For example `audio/m4a`,
     * `audio/x-alaw-basic`, `audio/mp3`, `audio/3gpp`.
     * A list of possible audio mime types is maintained at
     * http://www.iana.org/assignments/media-types/media-types.xhtml#audio
     * </pre>
     *
     * <code>string original_mime_type = 8;</code>
     * @return This builder for chaining.
     */
    public Builder clearOriginalMimeType() {
      copyOnWrite();
      instance.clearOriginalMimeType();
      return this;
    }
    /**
     * <pre>
     * Mime type of the original audio file.  For example `audio/m4a`,
     * `audio/x-alaw-basic`, `audio/mp3`, `audio/3gpp`.
     * A list of possible audio mime types is maintained at
     * http://www.iana.org/assignments/media-types/media-types.xhtml#audio
     * </pre>
     *
     * <code>string original_mime_type = 8;</code>
     * @param value The bytes for originalMimeType to set.
     * @return This builder for chaining.
     */
    public Builder setOriginalMimeTypeBytes(
        com.google.protobuf.ByteString value) {
      copyOnWrite();
      instance.setOriginalMimeTypeBytes(value);
      return this;
    }

    /**
     * <pre>
     * Description of the content. Eg. "Recordings of federal supreme court
     * hearings from 2012".
     * </pre>
     *
     * <code>string audio_topic = 10;</code>
     * @return The audioTopic.
     */
    @java.lang.Override
    public java.lang.String getAudioTopic() {
      return instance.getAudioTopic();
    }
    /**
     * <pre>
     * Description of the content. Eg. "Recordings of federal supreme court
     * hearings from 2012".
     * </pre>
     *
     * <code>string audio_topic = 10;</code>
     * @return The bytes for audioTopic.
     */
    @java.lang.Override
    public com.google.protobuf.ByteString
        getAudioTopicBytes() {
      return instance.getAudioTopicBytes();
    }
    /**
     * <pre>
     * Description of the content. Eg. "Recordings of federal supreme court
     * hearings from 2012".
     * </pre>
     *
     * <code>string audio_topic = 10;</code>
     * @param value The audioTopic to set.
     * @return This builder for chaining.
     */
    public Builder setAudioTopic(
        java.lang.String value) {
      copyOnWrite();
      instance.setAudioTopic(value);
      return this;
    }
    /**
     * <pre>
     * Description of the content. Eg. "Recordings of federal supreme court
     * hearings from 2012".
     * </pre>
     *
     * <code>string audio_topic = 10;</code>
     * @return This builder for chaining.
     */
    public Builder clearAudioTopic() {
      copyOnWrite();
      instance.clearAudioTopic();
      return this;
    }
    /**
     * <pre>
     * Description of the content. Eg. "Recordings of federal supreme court
     * hearings from 2012".
     * </pre>
     *
     * <code>string audio_topic = 10;</code>
     * @param value The bytes for audioTopic to set.
     * @return This builder for chaining.
     */
    public Builder setAudioTopicBytes(
        com.google.protobuf.ByteString value) {
      copyOnWrite();
      instance.setAudioTopicBytes(value);
      return this;
    }

    // @@protoc_insertion_point(builder_scope:google.cloud.speech.v1.RecognitionMetadata)
  }
  @java.lang.Override
  @java.lang.SuppressWarnings({"unchecked", "fallthrough"})
  protected final java.lang.Object dynamicMethod(
      com.google.protobuf.GeneratedMessageLite.MethodToInvoke method,
      java.lang.Object arg0, java.lang.Object arg1) {
    switch (method) {
      case NEW_MUTABLE_INSTANCE: {
        return new com.google.cloud.speech.v1.RecognitionMetadata();
      }
      case NEW_BUILDER: {
        return new Builder();
      }
      case BUILD_MESSAGE_INFO: {
          java.lang.Object[] objects = new java.lang.Object[] {
            "interactionType_",
            "industryNaicsCodeOfAudio_",
            "microphoneDistance_",
            "originalMediaType_",
            "recordingDeviceType_",
            "recordingDeviceName_",
            "originalMimeType_",
            "audioTopic_",
          };
          java.lang.String info =
              "\u0000\b\u0000\u0000\u0001\n\b\u0000\u0000\u0000\u0001\f\u0003\u000b\u0004\f\u0005" +
              "\f\u0006\f\u0007\u0208\b\u0208\n\u0208";
          return newMessageInfo(DEFAULT_INSTANCE, info, objects);
      }
      // fall through
      case GET_DEFAULT_INSTANCE: {
        return DEFAULT_INSTANCE;
      }
      case GET_PARSER: {
        com.google.protobuf.Parser<com.google.cloud.speech.v1.RecognitionMetadata> parser = PARSER;
        if (parser == null) {
          synchronized (com.google.cloud.speech.v1.RecognitionMetadata.class) {
            parser = PARSER;
            if (parser == null) {
              parser =
                  new DefaultInstanceBasedParser<com.google.cloud.speech.v1.RecognitionMetadata>(
                      DEFAULT_INSTANCE);
              PARSER = parser;
            }
          }
        }
        return parser;
    }
    case GET_MEMOIZED_IS_INITIALIZED: {
      return (byte) 1;
    }
    case SET_MEMOIZED_IS_INITIALIZED: {
      return null;
    }
    }
    throw new UnsupportedOperationException();
  }


  // @@protoc_insertion_point(class_scope:google.cloud.speech.v1.RecognitionMetadata)
  private static final com.google.cloud.speech.v1.RecognitionMetadata DEFAULT_INSTANCE;
  static {
    RecognitionMetadata defaultInstance = new RecognitionMetadata();
    // New instances are implicitly immutable so no need to make
    // immutable.
    DEFAULT_INSTANCE = defaultInstance;
    com.google.protobuf.GeneratedMessageLite.registerDefaultInstance(
      RecognitionMetadata.class, defaultInstance);
  }

  public static com.google.cloud.speech.v1.RecognitionMetadata getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static volatile com.google.protobuf.Parser<RecognitionMetadata> PARSER;

  public static com.google.protobuf.Parser<RecognitionMetadata> parser() {
    return DEFAULT_INSTANCE.getParserForType();
  }
}

