// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: google/speech/v1/cloud_speech.proto

package com.google.cloud.speech.v1;

/**
 * <pre>
 * The top-level message sent by the client for the `StreamingRecognize` method.
 * Multiple `StreamingRecognizeRequest` messages are sent. The first message
 * must contain a `streaming_config` message and must not contain
 * `audio_content`. All subsequent messages must contain `audio_content` and
 * must not contain a `streaming_config` message.
 * </pre>
 *
 * Protobuf type {@code google.cloud.speech.v1.StreamingRecognizeRequest}
 */
public  final class StreamingRecognizeRequest extends
    com.google.protobuf.GeneratedMessageLite<
        StreamingRecognizeRequest, StreamingRecognizeRequest.Builder> implements
    // @@protoc_insertion_point(message_implements:google.cloud.speech.v1.StreamingRecognizeRequest)
    StreamingRecognizeRequestOrBuilder {
  private StreamingRecognizeRequest() {
  }
  private int streamingRequestCase_ = 0;
  private java.lang.Object streamingRequest_;
  public enum StreamingRequestCase {
    STREAMING_CONFIG(1),
    AUDIO_CONTENT(2),
    STREAMINGREQUEST_NOT_SET(0);
    private final int value;
    private StreamingRequestCase(int value) {
      this.value = value;
    }
    /**
     * @deprecated Use {@link #forNumber(int)} instead.
     */
    @java.lang.Deprecated
    public static StreamingRequestCase valueOf(int value) {
      return forNumber(value);
    }

    public static StreamingRequestCase forNumber(int value) {
      switch (value) {
        case 1: return STREAMING_CONFIG;
        case 2: return AUDIO_CONTENT;
        case 0: return STREAMINGREQUEST_NOT_SET;
        default: return null;
      }
    }
    public int getNumber() {
      return this.value;
    }
  };

  @java.lang.Override
  public StreamingRequestCase
  getStreamingRequestCase() {
    return StreamingRequestCase.forNumber(
        streamingRequestCase_);
  }

  private void clearStreamingRequest() {
    streamingRequestCase_ = 0;
    streamingRequest_ = null;
  }

  public static final int STREAMING_CONFIG_FIELD_NUMBER = 1;
  /**
   * <pre>
   * Provides information to the recognizer that specifies how to process the
   * request. The first `StreamingRecognizeRequest` message must contain a
   * `streaming_config`  message.
   * </pre>
   *
   * <code>.google.cloud.speech.v1.StreamingRecognitionConfig streaming_config = 1;</code>
   */
  @java.lang.Override
  public boolean hasStreamingConfig() {
    return streamingRequestCase_ == 1;
  }
  /**
   * <pre>
   * Provides information to the recognizer that specifies how to process the
   * request. The first `StreamingRecognizeRequest` message must contain a
   * `streaming_config`  message.
   * </pre>
   *
   * <code>.google.cloud.speech.v1.StreamingRecognitionConfig streaming_config = 1;</code>
   */
  @java.lang.Override
  public com.google.cloud.speech.v1.StreamingRecognitionConfig getStreamingConfig() {
    if (streamingRequestCase_ == 1) {
       return (com.google.cloud.speech.v1.StreamingRecognitionConfig) streamingRequest_;
    }
    return com.google.cloud.speech.v1.StreamingRecognitionConfig.getDefaultInstance();
  }
  /**
   * <pre>
   * Provides information to the recognizer that specifies how to process the
   * request. The first `StreamingRecognizeRequest` message must contain a
   * `streaming_config`  message.
   * </pre>
   *
   * <code>.google.cloud.speech.v1.StreamingRecognitionConfig streaming_config = 1;</code>
   */
  private void setStreamingConfig(com.google.cloud.speech.v1.StreamingRecognitionConfig value) {
    value.getClass();
  streamingRequest_ = value;
    streamingRequestCase_ = 1;
  }
  /**
   * <pre>
   * Provides information to the recognizer that specifies how to process the
   * request. The first `StreamingRecognizeRequest` message must contain a
   * `streaming_config`  message.
   * </pre>
   *
   * <code>.google.cloud.speech.v1.StreamingRecognitionConfig streaming_config = 1;</code>
   */
  private void mergeStreamingConfig(com.google.cloud.speech.v1.StreamingRecognitionConfig value) {
    value.getClass();
  if (streamingRequestCase_ == 1 &&
        streamingRequest_ != com.google.cloud.speech.v1.StreamingRecognitionConfig.getDefaultInstance()) {
      streamingRequest_ = com.google.cloud.speech.v1.StreamingRecognitionConfig.newBuilder((com.google.cloud.speech.v1.StreamingRecognitionConfig) streamingRequest_)
          .mergeFrom(value).buildPartial();
    } else {
      streamingRequest_ = value;
    }
    streamingRequestCase_ = 1;
  }
  /**
   * <pre>
   * Provides information to the recognizer that specifies how to process the
   * request. The first `StreamingRecognizeRequest` message must contain a
   * `streaming_config`  message.
   * </pre>
   *
   * <code>.google.cloud.speech.v1.StreamingRecognitionConfig streaming_config = 1;</code>
   */
  private void clearStreamingConfig() {
    if (streamingRequestCase_ == 1) {
      streamingRequestCase_ = 0;
      streamingRequest_ = null;
    }
  }

  public static final int AUDIO_CONTENT_FIELD_NUMBER = 2;
  /**
   * <pre>
   * The audio data to be recognized. Sequential chunks of audio data are sent
   * in sequential `StreamingRecognizeRequest` messages. The first
   * `StreamingRecognizeRequest` message must not contain `audio_content` data
   * and all subsequent `StreamingRecognizeRequest` messages must contain
   * `audio_content` data. The audio bytes must be encoded as specified in
   * `RecognitionConfig`. Note: as with all bytes fields, proto buffers use a
   * pure binary representation (not base64). See
   * [content limits](https://cloud.google.com/speech-to-text/quotas#content).
   * </pre>
   *
   * <code>bytes audio_content = 2;</code>
   * @return The audioContent.
   */
  @java.lang.Override
  public com.google.protobuf.ByteString getAudioContent() {
    if (streamingRequestCase_ == 2) {
      return (com.google.protobuf.ByteString) streamingRequest_;
    }
    return com.google.protobuf.ByteString.EMPTY;
  }
  /**
   * <pre>
   * The audio data to be recognized. Sequential chunks of audio data are sent
   * in sequential `StreamingRecognizeRequest` messages. The first
   * `StreamingRecognizeRequest` message must not contain `audio_content` data
   * and all subsequent `StreamingRecognizeRequest` messages must contain
   * `audio_content` data. The audio bytes must be encoded as specified in
   * `RecognitionConfig`. Note: as with all bytes fields, proto buffers use a
   * pure binary representation (not base64). See
   * [content limits](https://cloud.google.com/speech-to-text/quotas#content).
   * </pre>
   *
   * <code>bytes audio_content = 2;</code>
   * @param value The audioContent to set.
   */
  private void setAudioContent(com.google.protobuf.ByteString value) {
    value.getClass();
  streamingRequestCase_ = 2;
    streamingRequest_ = value;
  }
  /**
   * <pre>
   * The audio data to be recognized. Sequential chunks of audio data are sent
   * in sequential `StreamingRecognizeRequest` messages. The first
   * `StreamingRecognizeRequest` message must not contain `audio_content` data
   * and all subsequent `StreamingRecognizeRequest` messages must contain
   * `audio_content` data. The audio bytes must be encoded as specified in
   * `RecognitionConfig`. Note: as with all bytes fields, proto buffers use a
   * pure binary representation (not base64). See
   * [content limits](https://cloud.google.com/speech-to-text/quotas#content).
   * </pre>
   *
   * <code>bytes audio_content = 2;</code>
   */
  private void clearAudioContent() {
    if (streamingRequestCase_ == 2) {
      streamingRequestCase_ = 0;
      streamingRequest_ = null;
    }
  }

  public static com.google.cloud.speech.v1.StreamingRecognizeRequest parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data);
  }
  public static com.google.cloud.speech.v1.StreamingRecognizeRequest parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data, extensionRegistry);
  }
  public static com.google.cloud.speech.v1.StreamingRecognizeRequest parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data);
  }
  public static com.google.cloud.speech.v1.StreamingRecognizeRequest parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data, extensionRegistry);
  }
  public static com.google.cloud.speech.v1.StreamingRecognizeRequest parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data);
  }
  public static com.google.cloud.speech.v1.StreamingRecognizeRequest parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data, extensionRegistry);
  }
  public static com.google.cloud.speech.v1.StreamingRecognizeRequest parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input);
  }
  public static com.google.cloud.speech.v1.StreamingRecognizeRequest parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input, extensionRegistry);
  }
  public static com.google.cloud.speech.v1.StreamingRecognizeRequest parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return parseDelimitedFrom(DEFAULT_INSTANCE, input);
  }
  public static com.google.cloud.speech.v1.StreamingRecognizeRequest parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return parseDelimitedFrom(DEFAULT_INSTANCE, input, extensionRegistry);
  }
  public static com.google.cloud.speech.v1.StreamingRecognizeRequest parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input);
  }
  public static com.google.cloud.speech.v1.StreamingRecognizeRequest parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input, extensionRegistry);
  }

  public static Builder newBuilder() {
    return (Builder) DEFAULT_INSTANCE.createBuilder();
  }
  public static Builder newBuilder(com.google.cloud.speech.v1.StreamingRecognizeRequest prototype) {
    return (Builder) DEFAULT_INSTANCE.createBuilder(prototype);
  }

  /**
   * <pre>
   * The top-level message sent by the client for the `StreamingRecognize` method.
   * Multiple `StreamingRecognizeRequest` messages are sent. The first message
   * must contain a `streaming_config` message and must not contain
   * `audio_content`. All subsequent messages must contain `audio_content` and
   * must not contain a `streaming_config` message.
   * </pre>
   *
   * Protobuf type {@code google.cloud.speech.v1.StreamingRecognizeRequest}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageLite.Builder<
        com.google.cloud.speech.v1.StreamingRecognizeRequest, Builder> implements
      // @@protoc_insertion_point(builder_implements:google.cloud.speech.v1.StreamingRecognizeRequest)
      com.google.cloud.speech.v1.StreamingRecognizeRequestOrBuilder {
    // Construct using com.google.cloud.speech.v1.StreamingRecognizeRequest.newBuilder()
    private Builder() {
      super(DEFAULT_INSTANCE);
    }

    @java.lang.Override
    public StreamingRequestCase
        getStreamingRequestCase() {
      return instance.getStreamingRequestCase();
    }

    public Builder clearStreamingRequest() {
      copyOnWrite();
      instance.clearStreamingRequest();
      return this;
    }


    /**
     * <pre>
     * Provides information to the recognizer that specifies how to process the
     * request. The first `StreamingRecognizeRequest` message must contain a
     * `streaming_config`  message.
     * </pre>
     *
     * <code>.google.cloud.speech.v1.StreamingRecognitionConfig streaming_config = 1;</code>
     */
    @java.lang.Override
    public boolean hasStreamingConfig() {
      return instance.hasStreamingConfig();
    }
    /**
     * <pre>
     * Provides information to the recognizer that specifies how to process the
     * request. The first `StreamingRecognizeRequest` message must contain a
     * `streaming_config`  message.
     * </pre>
     *
     * <code>.google.cloud.speech.v1.StreamingRecognitionConfig streaming_config = 1;</code>
     */
    @java.lang.Override
    public com.google.cloud.speech.v1.StreamingRecognitionConfig getStreamingConfig() {
      return instance.getStreamingConfig();
    }
    /**
     * <pre>
     * Provides information to the recognizer that specifies how to process the
     * request. The first `StreamingRecognizeRequest` message must contain a
     * `streaming_config`  message.
     * </pre>
     *
     * <code>.google.cloud.speech.v1.StreamingRecognitionConfig streaming_config = 1;</code>
     */
    public Builder setStreamingConfig(com.google.cloud.speech.v1.StreamingRecognitionConfig value) {
      copyOnWrite();
      instance.setStreamingConfig(value);
      return this;
    }
    /**
     * <pre>
     * Provides information to the recognizer that specifies how to process the
     * request. The first `StreamingRecognizeRequest` message must contain a
     * `streaming_config`  message.
     * </pre>
     *
     * <code>.google.cloud.speech.v1.StreamingRecognitionConfig streaming_config = 1;</code>
     */
    public Builder setStreamingConfig(
        com.google.cloud.speech.v1.StreamingRecognitionConfig.Builder builderForValue) {
      copyOnWrite();
      instance.setStreamingConfig(builderForValue.build());
      return this;
    }
    /**
     * <pre>
     * Provides information to the recognizer that specifies how to process the
     * request. The first `StreamingRecognizeRequest` message must contain a
     * `streaming_config`  message.
     * </pre>
     *
     * <code>.google.cloud.speech.v1.StreamingRecognitionConfig streaming_config = 1;</code>
     */
    public Builder mergeStreamingConfig(com.google.cloud.speech.v1.StreamingRecognitionConfig value) {
      copyOnWrite();
      instance.mergeStreamingConfig(value);
      return this;
    }
    /**
     * <pre>
     * Provides information to the recognizer that specifies how to process the
     * request. The first `StreamingRecognizeRequest` message must contain a
     * `streaming_config`  message.
     * </pre>
     *
     * <code>.google.cloud.speech.v1.StreamingRecognitionConfig streaming_config = 1;</code>
     */
    public Builder clearStreamingConfig() {
      copyOnWrite();
      instance.clearStreamingConfig();
      return this;
    }

    /**
     * <pre>
     * The audio data to be recognized. Sequential chunks of audio data are sent
     * in sequential `StreamingRecognizeRequest` messages. The first
     * `StreamingRecognizeRequest` message must not contain `audio_content` data
     * and all subsequent `StreamingRecognizeRequest` messages must contain
     * `audio_content` data. The audio bytes must be encoded as specified in
     * `RecognitionConfig`. Note: as with all bytes fields, proto buffers use a
     * pure binary representation (not base64). See
     * [content limits](https://cloud.google.com/speech-to-text/quotas#content).
     * </pre>
     *
     * <code>bytes audio_content = 2;</code>
     * @return The audioContent.
     */
    @java.lang.Override
    public com.google.protobuf.ByteString getAudioContent() {
      return instance.getAudioContent();
    }
    /**
     * <pre>
     * The audio data to be recognized. Sequential chunks of audio data are sent
     * in sequential `StreamingRecognizeRequest` messages. The first
     * `StreamingRecognizeRequest` message must not contain `audio_content` data
     * and all subsequent `StreamingRecognizeRequest` messages must contain
     * `audio_content` data. The audio bytes must be encoded as specified in
     * `RecognitionConfig`. Note: as with all bytes fields, proto buffers use a
     * pure binary representation (not base64). See
     * [content limits](https://cloud.google.com/speech-to-text/quotas#content).
     * </pre>
     *
     * <code>bytes audio_content = 2;</code>
     * @param value The audioContent to set.
     * @return This builder for chaining.
     */
    public Builder setAudioContent(com.google.protobuf.ByteString value) {
      copyOnWrite();
      instance.setAudioContent(value);
      return this;
    }
    /**
     * <pre>
     * The audio data to be recognized. Sequential chunks of audio data are sent
     * in sequential `StreamingRecognizeRequest` messages. The first
     * `StreamingRecognizeRequest` message must not contain `audio_content` data
     * and all subsequent `StreamingRecognizeRequest` messages must contain
     * `audio_content` data. The audio bytes must be encoded as specified in
     * `RecognitionConfig`. Note: as with all bytes fields, proto buffers use a
     * pure binary representation (not base64). See
     * [content limits](https://cloud.google.com/speech-to-text/quotas#content).
     * </pre>
     *
     * <code>bytes audio_content = 2;</code>
     * @return This builder for chaining.
     */
    public Builder clearAudioContent() {
      copyOnWrite();
      instance.clearAudioContent();
      return this;
    }

    // @@protoc_insertion_point(builder_scope:google.cloud.speech.v1.StreamingRecognizeRequest)
  }
  @java.lang.Override
  @java.lang.SuppressWarnings({"unchecked", "fallthrough"})
  protected final java.lang.Object dynamicMethod(
      com.google.protobuf.GeneratedMessageLite.MethodToInvoke method,
      java.lang.Object arg0, java.lang.Object arg1) {
    switch (method) {
      case NEW_MUTABLE_INSTANCE: {
        return new com.google.cloud.speech.v1.StreamingRecognizeRequest();
      }
      case NEW_BUILDER: {
        return new Builder();
      }
      case BUILD_MESSAGE_INFO: {
          java.lang.Object[] objects = new java.lang.Object[] {
            "streamingRequest_",
            "streamingRequestCase_",
            com.google.cloud.speech.v1.StreamingRecognitionConfig.class,
          };
          java.lang.String info =
              "\u0000\u0002\u0001\u0000\u0001\u0002\u0002\u0000\u0000\u0000\u0001<\u0000\u0002=" +
              "\u0000";
          return newMessageInfo(DEFAULT_INSTANCE, info, objects);
      }
      // fall through
      case GET_DEFAULT_INSTANCE: {
        return DEFAULT_INSTANCE;
      }
      case GET_PARSER: {
        com.google.protobuf.Parser<com.google.cloud.speech.v1.StreamingRecognizeRequest> parser = PARSER;
        if (parser == null) {
          synchronized (com.google.cloud.speech.v1.StreamingRecognizeRequest.class) {
            parser = PARSER;
            if (parser == null) {
              parser =
                  new DefaultInstanceBasedParser<com.google.cloud.speech.v1.StreamingRecognizeRequest>(
                      DEFAULT_INSTANCE);
              PARSER = parser;
            }
          }
        }
        return parser;
    }
    case GET_MEMOIZED_IS_INITIALIZED: {
      return (byte) 1;
    }
    case SET_MEMOIZED_IS_INITIALIZED: {
      return null;
    }
    }
    throw new UnsupportedOperationException();
  }


  // @@protoc_insertion_point(class_scope:google.cloud.speech.v1.StreamingRecognizeRequest)
  private static final com.google.cloud.speech.v1.StreamingRecognizeRequest DEFAULT_INSTANCE;
  static {
    StreamingRecognizeRequest defaultInstance = new StreamingRecognizeRequest();
    // New instances are implicitly immutable so no need to make
    // immutable.
    DEFAULT_INSTANCE = defaultInstance;
    com.google.protobuf.GeneratedMessageLite.registerDefaultInstance(
      StreamingRecognizeRequest.class, defaultInstance);
  }

  public static com.google.cloud.speech.v1.StreamingRecognizeRequest getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static volatile com.google.protobuf.Parser<StreamingRecognizeRequest> PARSER;

  public static com.google.protobuf.Parser<StreamingRecognizeRequest> parser() {
    return DEFAULT_INSTANCE.getParserForType();
  }
}

