// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: google/logging/v2/logging_config.proto

package com.google.logging.v2;

/**
 * <pre>
 * Options that change functionality of a sink exporting data to BigQuery.
 * </pre>
 *
 * Protobuf type {@code google.logging.v2.BigQueryOptions}
 */
public  final class BigQueryOptions extends
    com.google.protobuf.GeneratedMessageLite<
        BigQueryOptions, BigQueryOptions.Builder> implements
    // @@protoc_insertion_point(message_implements:google.logging.v2.BigQueryOptions)
    BigQueryOptionsOrBuilder {
  private BigQueryOptions() {
  }
  public static final int USE_PARTITIONED_TABLES_FIELD_NUMBER = 1;
  private boolean usePartitionedTables_;
  /**
   * <pre>
   * Optional. Whether to use [BigQuery's partition
   * tables](https://cloud.google.com/bigquery/docs/partitioned-tables). By
   * default, Logging creates dated tables based on the log entries' timestamps,
   * e.g. syslog_20170523. With partitioned tables the date suffix is no longer
   * present and [special query
   * syntax](https://cloud.google.com/bigquery/docs/querying-partitioned-tables)
   * has to be used instead. In both cases, tables are sharded based on UTC
   * timezone.
   * </pre>
   *
   * <code>bool use_partitioned_tables = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
   * @return The usePartitionedTables.
   */
  @java.lang.Override
  public boolean getUsePartitionedTables() {
    return usePartitionedTables_;
  }
  /**
   * <pre>
   * Optional. Whether to use [BigQuery's partition
   * tables](https://cloud.google.com/bigquery/docs/partitioned-tables). By
   * default, Logging creates dated tables based on the log entries' timestamps,
   * e.g. syslog_20170523. With partitioned tables the date suffix is no longer
   * present and [special query
   * syntax](https://cloud.google.com/bigquery/docs/querying-partitioned-tables)
   * has to be used instead. In both cases, tables are sharded based on UTC
   * timezone.
   * </pre>
   *
   * <code>bool use_partitioned_tables = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
   * @param value The usePartitionedTables to set.
   */
  private void setUsePartitionedTables(boolean value) {
    
    usePartitionedTables_ = value;
  }
  /**
   * <pre>
   * Optional. Whether to use [BigQuery's partition
   * tables](https://cloud.google.com/bigquery/docs/partitioned-tables). By
   * default, Logging creates dated tables based on the log entries' timestamps,
   * e.g. syslog_20170523. With partitioned tables the date suffix is no longer
   * present and [special query
   * syntax](https://cloud.google.com/bigquery/docs/querying-partitioned-tables)
   * has to be used instead. In both cases, tables are sharded based on UTC
   * timezone.
   * </pre>
   *
   * <code>bool use_partitioned_tables = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
   */
  private void clearUsePartitionedTables() {
    
    usePartitionedTables_ = false;
  }

  public static final int USES_TIMESTAMP_COLUMN_PARTITIONING_FIELD_NUMBER = 3;
  private boolean usesTimestampColumnPartitioning_;
  /**
   * <pre>
   * Output only. True if new timestamp column based partitioning is in use,
   * false if legacy ingestion-time partitioning is in use.
   * All new sinks will have this field set true and will use timestamp column
   * based partitioning. If use_partitioned_tables is false, this value has no
   * meaning and will be false. Legacy sinks using partitioned tables will have
   * this field set to false.
   * </pre>
   *
   * <code>bool uses_timestamp_column_partitioning = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
   * @return The usesTimestampColumnPartitioning.
   */
  @java.lang.Override
  public boolean getUsesTimestampColumnPartitioning() {
    return usesTimestampColumnPartitioning_;
  }
  /**
   * <pre>
   * Output only. True if new timestamp column based partitioning is in use,
   * false if legacy ingestion-time partitioning is in use.
   * All new sinks will have this field set true and will use timestamp column
   * based partitioning. If use_partitioned_tables is false, this value has no
   * meaning and will be false. Legacy sinks using partitioned tables will have
   * this field set to false.
   * </pre>
   *
   * <code>bool uses_timestamp_column_partitioning = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
   * @param value The usesTimestampColumnPartitioning to set.
   */
  private void setUsesTimestampColumnPartitioning(boolean value) {
    
    usesTimestampColumnPartitioning_ = value;
  }
  /**
   * <pre>
   * Output only. True if new timestamp column based partitioning is in use,
   * false if legacy ingestion-time partitioning is in use.
   * All new sinks will have this field set true and will use timestamp column
   * based partitioning. If use_partitioned_tables is false, this value has no
   * meaning and will be false. Legacy sinks using partitioned tables will have
   * this field set to false.
   * </pre>
   *
   * <code>bool uses_timestamp_column_partitioning = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
   */
  private void clearUsesTimestampColumnPartitioning() {
    
    usesTimestampColumnPartitioning_ = false;
  }

  public static com.google.logging.v2.BigQueryOptions parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data);
  }
  public static com.google.logging.v2.BigQueryOptions parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data, extensionRegistry);
  }
  public static com.google.logging.v2.BigQueryOptions parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data);
  }
  public static com.google.logging.v2.BigQueryOptions parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data, extensionRegistry);
  }
  public static com.google.logging.v2.BigQueryOptions parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data);
  }
  public static com.google.logging.v2.BigQueryOptions parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data, extensionRegistry);
  }
  public static com.google.logging.v2.BigQueryOptions parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input);
  }
  public static com.google.logging.v2.BigQueryOptions parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input, extensionRegistry);
  }
  public static com.google.logging.v2.BigQueryOptions parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return parseDelimitedFrom(DEFAULT_INSTANCE, input);
  }
  public static com.google.logging.v2.BigQueryOptions parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return parseDelimitedFrom(DEFAULT_INSTANCE, input, extensionRegistry);
  }
  public static com.google.logging.v2.BigQueryOptions parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input);
  }
  public static com.google.logging.v2.BigQueryOptions parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input, extensionRegistry);
  }

  public static Builder newBuilder() {
    return (Builder) DEFAULT_INSTANCE.createBuilder();
  }
  public static Builder newBuilder(com.google.logging.v2.BigQueryOptions prototype) {
    return (Builder) DEFAULT_INSTANCE.createBuilder(prototype);
  }

  /**
   * <pre>
   * Options that change functionality of a sink exporting data to BigQuery.
   * </pre>
   *
   * Protobuf type {@code google.logging.v2.BigQueryOptions}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageLite.Builder<
        com.google.logging.v2.BigQueryOptions, Builder> implements
      // @@protoc_insertion_point(builder_implements:google.logging.v2.BigQueryOptions)
      com.google.logging.v2.BigQueryOptionsOrBuilder {
    // Construct using com.google.logging.v2.BigQueryOptions.newBuilder()
    private Builder() {
      super(DEFAULT_INSTANCE);
    }


    /**
     * <pre>
     * Optional. Whether to use [BigQuery's partition
     * tables](https://cloud.google.com/bigquery/docs/partitioned-tables). By
     * default, Logging creates dated tables based on the log entries' timestamps,
     * e.g. syslog_20170523. With partitioned tables the date suffix is no longer
     * present and [special query
     * syntax](https://cloud.google.com/bigquery/docs/querying-partitioned-tables)
     * has to be used instead. In both cases, tables are sharded based on UTC
     * timezone.
     * </pre>
     *
     * <code>bool use_partitioned_tables = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return The usePartitionedTables.
     */
    @java.lang.Override
    public boolean getUsePartitionedTables() {
      return instance.getUsePartitionedTables();
    }
    /**
     * <pre>
     * Optional. Whether to use [BigQuery's partition
     * tables](https://cloud.google.com/bigquery/docs/partitioned-tables). By
     * default, Logging creates dated tables based on the log entries' timestamps,
     * e.g. syslog_20170523. With partitioned tables the date suffix is no longer
     * present and [special query
     * syntax](https://cloud.google.com/bigquery/docs/querying-partitioned-tables)
     * has to be used instead. In both cases, tables are sharded based on UTC
     * timezone.
     * </pre>
     *
     * <code>bool use_partitioned_tables = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param value The usePartitionedTables to set.
     * @return This builder for chaining.
     */
    public Builder setUsePartitionedTables(boolean value) {
      copyOnWrite();
      instance.setUsePartitionedTables(value);
      return this;
    }
    /**
     * <pre>
     * Optional. Whether to use [BigQuery's partition
     * tables](https://cloud.google.com/bigquery/docs/partitioned-tables). By
     * default, Logging creates dated tables based on the log entries' timestamps,
     * e.g. syslog_20170523. With partitioned tables the date suffix is no longer
     * present and [special query
     * syntax](https://cloud.google.com/bigquery/docs/querying-partitioned-tables)
     * has to be used instead. In both cases, tables are sharded based on UTC
     * timezone.
     * </pre>
     *
     * <code>bool use_partitioned_tables = 1 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return This builder for chaining.
     */
    public Builder clearUsePartitionedTables() {
      copyOnWrite();
      instance.clearUsePartitionedTables();
      return this;
    }

    /**
     * <pre>
     * Output only. True if new timestamp column based partitioning is in use,
     * false if legacy ingestion-time partitioning is in use.
     * All new sinks will have this field set true and will use timestamp column
     * based partitioning. If use_partitioned_tables is false, this value has no
     * meaning and will be false. Legacy sinks using partitioned tables will have
     * this field set to false.
     * </pre>
     *
     * <code>bool uses_timestamp_column_partitioning = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return The usesTimestampColumnPartitioning.
     */
    @java.lang.Override
    public boolean getUsesTimestampColumnPartitioning() {
      return instance.getUsesTimestampColumnPartitioning();
    }
    /**
     * <pre>
     * Output only. True if new timestamp column based partitioning is in use,
     * false if legacy ingestion-time partitioning is in use.
     * All new sinks will have this field set true and will use timestamp column
     * based partitioning. If use_partitioned_tables is false, this value has no
     * meaning and will be false. Legacy sinks using partitioned tables will have
     * this field set to false.
     * </pre>
     *
     * <code>bool uses_timestamp_column_partitioning = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param value The usesTimestampColumnPartitioning to set.
     * @return This builder for chaining.
     */
    public Builder setUsesTimestampColumnPartitioning(boolean value) {
      copyOnWrite();
      instance.setUsesTimestampColumnPartitioning(value);
      return this;
    }
    /**
     * <pre>
     * Output only. True if new timestamp column based partitioning is in use,
     * false if legacy ingestion-time partitioning is in use.
     * All new sinks will have this field set true and will use timestamp column
     * based partitioning. If use_partitioned_tables is false, this value has no
     * meaning and will be false. Legacy sinks using partitioned tables will have
     * this field set to false.
     * </pre>
     *
     * <code>bool uses_timestamp_column_partitioning = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return This builder for chaining.
     */
    public Builder clearUsesTimestampColumnPartitioning() {
      copyOnWrite();
      instance.clearUsesTimestampColumnPartitioning();
      return this;
    }

    // @@protoc_insertion_point(builder_scope:google.logging.v2.BigQueryOptions)
  }
  @java.lang.Override
  @java.lang.SuppressWarnings({"unchecked", "fallthrough"})
  protected final java.lang.Object dynamicMethod(
      com.google.protobuf.GeneratedMessageLite.MethodToInvoke method,
      java.lang.Object arg0, java.lang.Object arg1) {
    switch (method) {
      case NEW_MUTABLE_INSTANCE: {
        return new com.google.logging.v2.BigQueryOptions();
      }
      case NEW_BUILDER: {
        return new Builder();
      }
      case BUILD_MESSAGE_INFO: {
          java.lang.Object[] objects = new java.lang.Object[] {
            "usePartitionedTables_",
            "usesTimestampColumnPartitioning_",
          };
          java.lang.String info =
              "\u0000\u0002\u0000\u0000\u0001\u0003\u0002\u0000\u0000\u0000\u0001\u0007\u0003\u0007" +
              "";
          return newMessageInfo(DEFAULT_INSTANCE, info, objects);
      }
      // fall through
      case GET_DEFAULT_INSTANCE: {
        return DEFAULT_INSTANCE;
      }
      case GET_PARSER: {
        com.google.protobuf.Parser<com.google.logging.v2.BigQueryOptions> parser = PARSER;
        if (parser == null) {
          synchronized (com.google.logging.v2.BigQueryOptions.class) {
            parser = PARSER;
            if (parser == null) {
              parser =
                  new DefaultInstanceBasedParser<com.google.logging.v2.BigQueryOptions>(
                      DEFAULT_INSTANCE);
              PARSER = parser;
            }
          }
        }
        return parser;
    }
    case GET_MEMOIZED_IS_INITIALIZED: {
      return (byte) 1;
    }
    case SET_MEMOIZED_IS_INITIALIZED: {
      return null;
    }
    }
    throw new UnsupportedOperationException();
  }


  // @@protoc_insertion_point(class_scope:google.logging.v2.BigQueryOptions)
  private static final com.google.logging.v2.BigQueryOptions DEFAULT_INSTANCE;
  static {
    BigQueryOptions defaultInstance = new BigQueryOptions();
    // New instances are implicitly immutable so no need to make
    // immutable.
    DEFAULT_INSTANCE = defaultInstance;
    com.google.protobuf.GeneratedMessageLite.registerDefaultInstance(
      BigQueryOptions.class, defaultInstance);
  }

  public static com.google.logging.v2.BigQueryOptions getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static volatile com.google.protobuf.Parser<BigQueryOptions> PARSER;

  public static com.google.protobuf.Parser<BigQueryOptions> parser() {
    return DEFAULT_INSTANCE.getParserForType();
  }
}

